/**
 * Protect window.console method calls, e.g. console is not defined on IE
 * unless dev tools are open, and IE doesn't define console.debug
 */
(function() {
  if (!window.console) {
    window.console = {};
  }
  // union of Chrome, FF, IE, and Safari console methods
  var m = [
    "log", "info", "warn", "error", "debug", "trace", "dir", "group",
    "groupCollapsed", "groupEnd", "time", "timeEnd", "profile", "profileEnd",
    "dirxml", "assert", "count", "markTimeline", "timeStamp", "clear"
  ];
  // define undefined methods as noops to prevent errors
  for (var i = 0; i < m.length; i++) {
    if (!window.console[m[i]]) {
      window.console[m[i]] = function() {};
    }    
  } 
})();

if (!Array.prototype.indexOf) { 
    Array.prototype.indexOf = function(obj, start) {
         for (var i = (start || 0), j = this.length; i < j; i++) {
             if (this[i] === obj) { return i; }
         }
         return -1;
    }
}

console.log("loading FScommon.js");
// Global vars
// eventData and eventStatus hold all metadata for a show
// i.e. event names, station names, tagmapping, etc.
window.eventData = {};
window.eventStatus = {};			
window.counts = {};
counts.registrations = 0;
counts.photographs = 0;
counts.checkins = 0;
counts.thirdparty = 0;
counts.giveaway = 0;
counts.coderegistration = 0;
counts.waivers = 0;
counts.votes = 0;
// added for tower
counts.totalLongReachTags = 0;
counts.totalDeletedInactiveTags = 0;
counts.currentActiveTags = 0;
counts.currentInactiveTags = 0;
counts.totalLongReachTagActivations = 0;
counts.totalShortReachTagActivations = 0;
counts.maxActiveTags = 0;
counts.totalHfTagActivations = 0;
counts.hfTagWrites = 0;
counts.hfTagWriteErrors = 0;
counts.hfTagReads = 0;
counts.hfTagReadErrors = 0;
counts.shortReachTagReads = 0;
counts.shortReachTagReadErrors = 0;
counts.shortReachTagWrites = 0;
counts.shortReachTagWriteErrors = 0;
counts.tagWriteValueCounter = 0;
counts.batAC = 0;
counts.battery1Charge = 0;
counts.battery2Charge = 0;
counts.readerTemp = 0;
counts.lowLevelFail = 0;
counts.lowLevelInit = 0;
counts.checkinFail = 0;
counts.checkinSuccess = 0;

var lowerLevelInit = false;
var waitingForLowLevel = true;
var checkinState = false;

var jsqueue = Array();
var androidUndefined = false;
var windowsMode = false;
var routerCompatibilityMode = true;

var testingJS = "test";
var firstRunPanel = true;

function preventBehavior(e) {
    e.preventDefault(); 
};

//document.addEventListener("touchmove", preventBehavior, false);

if(typeof Android == 'undefined')
{
    androidUndefined = true;
    if(typeof window.external != 'undefined') windowsMode = true;
    window.Android = {};
    Android.callC = function(response) {
        callC(response);
    };
}

if(!androidUndefined)
{
    log("starting kioskMessageLoop");
    setTimeout("getKioskMessageLoop();",1000); // start message loop
}

function setRouterCompatibilityMode(){
    if(typeof setRfidStop == 'undefined'){
        log("setting router compatibility mode");
        routerCompatibilityMode = true;
    } else routerCompatibilityMode = false;
}

function callC(callStr)
{
    try
    {
        if(!androidUndefined && !windowsMode) Android.callC(callStr);
        else if(windowsMode) window.external.callC(callStr);
        else
        {
            jsqueue.push(callStr);
        }
    }
    catch(err)
    {
//        alert(err);
        console.log("callC error: " + err);
    }
    if(callStr.indexOf("setRfidStop") != -1 && routerCompatibilityMode ) resetAfterReadWrite();
}

function getTesting(){
    return testingJS;
}

function addToQueue(arr)
{
    jsqueue.push(arr);
}

function getQueue() 
{
    var arg = jsqueue.shift();
    return arg ? arg : "";
}

function queueEmpty()
{
    if(jsqueue.length > 0) return "false";
    else return "true";
}



// for handling queue and C# calls

var msgQueue = [];

function getKioskMessageLoop()
{
	var messageReceived = Android.getKioskMessage();
	var kioskMessages = messageReceived.split("-n-");
	var message;
	for(var i5 = 0; i5 < kioskMessages.length; i5++){
	   message = kioskMessages[i5];
	   msgQueue.push(message);
	 }
	 
	 while(true){
	 	message = msgQueue.shift();
	 	if(typeof message === 'undefined') break;
	 	
 		if(message.indexOf("lowerLevelInit") != -1){
			lowerLevelInit = true;
			log("lowLevelInit complete while waiting: "+waitingForLowLevel.toString());
			break;
		}
		
		if(message.indexOf("lowerLevelFail") != -1){
			lowerLevelInit = false;
			waitingForLowLevel = true;
			log("lowLevel Failed...");
			lowLevelFail();//common low level monitor
			break;
		}
		
		if(message != ""){
			message2 = message;
			setTimeout("executeMessage();",10);
			return;
		}
	 	
	 }

	setTimeout("getKioskMessageLoop();",150);
}

var message2;
function executeMessage(){
	try{
		//log("-------" + message2);
		eval(message2);
	}
	catch(err){log("executeErr: "+err.toString()+" message: "+message2);}
	setTimeout("getKioskMessageLoop();",150);
}


function adaptIndex(){
  $('body').append('<div class="panelIcon"></div>');
  setTimeout("fixIcons();",200);
}

function lowLevelInit(){
	lowLevelStatCount++;
	if(!lowerLevelInit){
		log("lowLevelInit");
		counts.lowLevelInit++;
	}
	lowerLevelInit = true;
	lowLevelStatCount++;
}

function lowLevelFail(){
	lowLevelStatCount++;
	if(lowerLevelInit){
		log("lowLevelInit fail");
		counts.lowLevelFail++;
	}
	waitingForLowLevel = true;
	lowerLevelInit = false;
}

var lowLevelStatCount = 0;

function batteryLevel(level){
	var i = parseInt(level);
	if(counts.battery1Charge != i){
		counts.battery1Charge = parseInt(level);
		if (typeof countsPersist !== 'undefined') {
			countsPersist();
		}
	}
}

var lowLevelReport = "";

function lowLevelMonitor(){
	if(lowLevelStatCount == 0 && false){//unify after NFL
		if(lowerLevelInit){
			counts.lowLevelFail++;
			log("lowLevelInit fail due to response timeout");
		}
		lowerLevelInit = false;
	}
	var changedState = false;
	var r = "lowerLevelInit: "+lowerLevelInit.toString()+" checkinSuccess: "+checkinState.toString()+" queue: "+parseInt(eventStatus.Queue).toString();
	if(r != lowLevelReport){
		log("lowLevelMonitor2. "+r);
		lowLevelReport = r;
		changedState = true;
	}
	
	$('.menuIcon').removeClass('menuIcon4').removeClass('menuIcon3').removeClass('menuIcon2').removeClass('menuIcon1');
	
//	log("lowLevelMonitor checking....");
	
    if(!lowerLevelInit){
//    	log("setting icon1");
    	$('.menuIcon').addClass('menuIcon1'); 
    	}
    	else{
          if(!checkinState){
//          log("setting icon2");
         $('.menuIcon').addClass('menuIcon2');
        } else {
            if(parseInt(eventStatus.Queue) > 50){
//                log("indicating queue too large");
                $('.menuIcon').addClass('menuIcon3');
            } else{
//                log("indicating all is well");
                $('.menuIcon').addClass('menuIcon4');
            }
        }
    }
    if(changedState){
	    $('.menuIcon').hide();
	    setTimeout("$('.menuIcon').show();",10);
	}
    
//    log("lowLevelMonitor finished checking...");
    
try{
    if(!androidUndefined)
    {
 //       log("trying to get IP address");
        var ip = Android.getIPAddress();
    	//log("got ip address: "+ip);
    	if(ip != ""){
    		 $('#ipAddress').parent().show();
        	 $('#ipAddress').text(ip);
        } else  $('#ipAddress').parent().hide();
        
    //    log("lowLevelMonitor finished ip address stuff");
    }
} catch(err) {}
	callC("lowLevelStatus");
	lowLevelStatCount = 0;
	setTimeout("lowLevelMonitor();",5000);
//	log("lowLevelMonitor done...");
}

function checkinFail(){
	checkinState = false;
	counts.checkinFail++;
}

function checkinSuccess(){
	checkinState = true;
	counts.checkinSuccess++;
}


var branchTo;
var lastAuthToken = '';
var lastTagId = '';
var lastLatitude;
var lastLongitude;
var currentPicture;	
var pictvisible = false;
var lastPhotoPage;
var rotateCheck2;			
var authFailFunction = "";
var authSucceedFunction = "";
var rfidTransition = "";
var gpsTransition = "";				
var guestToken = "";
var callbackForReadFile = null;

var clickHandler = ('ontouchstart' in document.documentElement ? "touchstart" : "click");

// add eventHandler on .next button
$('.next').on(clickHandler, function(){/* surface- was "click" */
    validateMyForm();
});

var inpanel = false;

// DOUBLE TAP FOR SETTINGS
$('.menuIcon').doubletap(
        function(event){
            // tap twice code here
            log("menuIcon tap");

            var allPanels = $('.accordion > dd').hide();
            $('.accordion > dt > a').removeClass('active');
            allPanels.removeClass('active').slideUp();
			$('.menuIcon').css('text-indent',"-9999px");
            $('#panel').hide();
            inpanel = false;
            if(loadingApp) return;
            if(typeof clearFields !== 'undefined') clearFields();
            init();
            loadApp(startingPage);
        },
        function(event){
            if(inpanel){
                log("menuIcon tap");

                var allPanels = $('.accordion > dd').hide();
                $('.accordion > dt > a').removeClass('active');
                allPanels.removeClass('active').slideUp();
				$('.menuIcon').css('text-indent',"-9999px");
                $('#panel').hide();
                inpanel = false;
                if(loadingApp) return;
                if(typeof clearFields !== 'undefined') clearFields();
                init();
                loadApp(startingPage);
                // tapped once code here
            }
        },
        600
); 




//function changePage(page){
//	setTimeout("changePageProcess('"+page+"');",100);
//}
// routing for pages

var panelEntryPage = "settings";

function changePage(page){
    // previousPage is page we change from
    if(page.indexOf('#')!=-1) page = page.split('#').pop();
    if(page == panelEntryPage) $(".panelIcon").show(); else $(".panelIcon").hide();
    log("changePage. "+page);
	previousPage = $('.page:visible').attr('id');
    // hide the previousPage
	$('#'+previousPage).hide();
	$('#'+page).hide();
    currentPage = page;
	//currentPage = $('.page:visible').attr('id');
	reshow = page;
	setTimeout("reshowPage();",100);
}

var reshow = "";

function reshowPage(){
	$('#'+reshow).show();
//    $('.content').scrollTop(0.1);
//    $('body').scrollTop(0.1);
    if(typeof(pageChanged)=='function') pageChanged(reshow);
}

// braching for form options, this function sets var branchTo
function branching(){
    log("branching - starting...");
    currentPage = $('#content .page:visible').attr('id');
    if (currentPage) {
        log("branching - exists currentPage = "+currentPage);
        var dataBranch = $('#'+currentPage+' input:checked').attr('data-branch');
        if ( dataBranch !== undefined){   
            nextPage = $('#'+currentPage+' input:checked').attr('data-branch');
        }else{
            nextPage = $('#'+currentPage).nextAll('div').attr('id');
            if (nextPage === undefined) nextPage = currentPage;
        }
    } else {
        log("branching - no currentPage = "+currentPage);
        currentPage = $('#content .page:first').attr('id');
        if(typeof currentPage == 'undefined') currentPage = "settings";
        nextPage = currentPage;
    }

    branchTo = nextPage;
    route(branchTo);
    log("branching - done.");
}

// validation of entered content if passes, call route(branchTo)
function validateMyForm() {
    log("validateMyForm - starting...");
    var a = $('form').length;
    if (a < 1) {
        log("validateMyForm - no form present on page, assuming validation");
        a = true;
    } else {
        a = jQuery('form').validationEngine('validate');
    }
    if (a == true){
        log("validateMyForm - form validated, calling route() with branchTo = "+branchTo);
        $('form').serializeForm();
        //console.log("validateMyForm - pad = "+JSON.stringify(pad));
        branching();
    } else {
        log("validateMyForm - form did not validate!");
    }
    log("validateMyForm - done.");
}

function capitalizeName(word, id) {
     //var lowerWord = word.toLowerCase();
     //var name = lowerWord.charAt(0).toUpperCase() + lowerWord.slice(1);
     //return $(id).val(name);
     var str = word,
    exceptions = ['and', 'etc'];

    str = str.toLowerCase().replace(/\b([a-z])\w*\b/g, convert);

    function convert(word, firstChar) {
        if ($.inArray(word, exceptions) > 0) {
            return word;
        }
        return firstChar.toUpperCase() + word.substr(1);
    }
    return $(id).val(str);
}

var lastCounts = "";

function statsUpdateMonitor(){
	var e = JSON.stringify(counts);	
	if(e != lastCounts){
		callC("uploadStats;");
		lastCounts = e;
	}
	setTimeout("statsUpdateMonitor();",300000);
}

function stripPhone(numb){
    numb = numb.replace(/[^0-9]/g, ''); 
    return numb;
}

function lowerCaseEmail() {
    var email = $('#email').val().toLowerCase();
    $('#email').val(email);
};

// for logging to the C# debug output
function log_2(text){
	if(typeof text == 'undefined' || text == "" || (typeof text !== 'string') ) return;
	var t = text.split(";");
	var s;
	if(t.length != 1) s = t.join("$$$"); else s=text;
    callC("log;{\"arg1\": \"web\", \"arg2\": \"" + s + "\"}");
};

/*function log(text){
	setTimeout(function(){
		log2(text);
	},10);
}*/

function log(text){
	log_2(text);
}

// commonly used js calls
function lookupPerson() {
    timeout_init();
    sendCommand('search_person',{"guest_id":lastTagId,"id_type":"RFID Tag Id"},lookupPersonCallback);
    // lookupPersonCallback can be found in app.js
}

function lookupCode() {
    timeout_init();
    var code = $('#code').val();
    sendCommand('search_person',{"guest_id":code,"id_type":codeOrEmail(code)},lookupCodeCallback);
    // lookupPersonCallback can be found in app.js
}

function getId() {
    // generates a guest ID
    return "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx".replace(/x/g, function() {
        return Math.floor(Math.random()*16).toString(16).toUpperCase();
    });
}

// common RFID handling functions
function singleRfidReadSuccess(rfidTransition){
    log("rfidReadSuccess (page): "+currentPage+" barcoding: "+barcoding.toString());
    branching();
}

function multiRfidStart(){
    rfidReadSuccess = gotTag;
    rfidTransition = '';
    callC("setRfidPending");
}

function gotTag(){
    if(lastTagId != ""){
        if(jQuery.inArray(lastTagId,photoTags) == -1){
            log("gotTag unique id: "+lastTagId);
            photoTags.push(lastTagId);
        }
    }
    var strMode = mode.substr(0,5);
    if (strMode === "photo"){
        photoScans = photoTags.length;
        log("gotTag current array size: "+photoScans);
        $('#photoScan h3.number').text(photoScans.toString());
        callC("setRfidPending");
        log("finished setting rfid pending");
    }
}

function phoneToInt(){
    phone = $('#phone').val();
    phone = phone.replace(/\D/gi,"");
    $('#phone').val(phone);
}

function codeOrEmail(code){
    val = code;
    if (val.search('@') > 0) {
        //console.log(' its email');
        type = "Email";
        return type;
    }else{
        //console.log(' its code');
        type = "url_id";
        return type;
    }
}


function integrationStatus(status){
    return /// add later			
}

// relating to the control panel
function launchControl(event,status){
    log("launchControl - starting... zoneManagement: "+ zoneConfig["enableZoneMangement"] );	
    callC("setRfidStop;{}");			
    inpanel = true;		
    refreshControl(event,status,"true");
    if(typeof route !== 'undefined') route("panel"); else changePage("panel");
    log("enableZoneManagement:" + zoneConfig["enableZoneManagement"]);
    if((typeof(zoneConfig["enableZoneManagement"]) !== 'undefined') && zoneConfig["enableZoneManagement"]){
    	log("showing zone panels");
    	$(".zonePanel").show();
    } else{
    	log("hiding zone panels");
    	$(".zonePanel").hide();
    }
    log("launchControl - done");					
}

function refreshControl(event,status,force){
   log("refreshControl = Starting...");

    for (var key in event) {
        eventData[key] = event[key];
    }
    for (var key in status) {
        eventStatus[key] = status[key];
    }
    
    if(typeof(refreshControlCalled)!='undefined') refreshControlCalled();
    
	if(inpanel){
	    // refresh Status and Event Info on Panel
	    if (typeof countItems !== 'undefined') {
	        countItems();
	    }
	    if (typeof eventItems !== 'undefined') {
	            eventItems();
	    }
	    if (typeof statusItems !== 'undefined') {
	            statusItems();
	    }
	   }
	   
    if(typeof fs_tag !== 'undefined'){
    	tagmapping = eventData['wristband_mapping'];
    }	

    if(eventStatus.Checkins == "fail"){
        eventStatus.Server_running = "fail";
    }	

    log("refreshControl - done.");
}	

function updateEvent(){
    log("updateEvent - starting...");
    e = JSON.stringify(eventData);					
    callC("updateEvent;"+e);
}

function resetStatus(){

}

function killControl(){
    changePage(pageWhenControlShift);			
}			

function inlineFBauth(now,success,fail){
    authFailFunction = fail;
    lastAuthToken = "";
    authSucceedFunction = success;
    var args = {}; 
    args.guest_id = currentGuest;
    args = JSON.stringify(args);
    callC("inlineFBauth;"+args);
    if(typeof(now)!="undefined" && now != '') route(now);
}		

function inlineTWauth(now,success,fail){
    authFailFunction = fail;
    lastAuthToken = "";
    authSucceedFunction = success;
    var args = {}; 
    args.guest_id = currentGuest;
    args = JSON.stringify(args);
    callC("inlineTWauth;"+args);
    if(typeof(now)!="undefined" && now != '') route(now);
}

function incCheckins(){
    callC("incCheckins");	
}

function displayPostAuth(token){
    lastAuthToken = token;		
    log('authSuccess - calling: ' + authSucceedFunction);
    log('lastAuthToken: ' + lastAuthToken);
    if(authSucceedFunction != "") eval(authSucceedFunction);
}

function authFailure(){
    log('authFailure - calling: ' + authFailFunction);
    lastAuthToken = "";
    if(authFailFunction != '' ) eval(authFailFunction);
    //changePage( "#ninth");
}			

function rfidRead(tagId){
    if (barcoding === false && tagId === ''){
        return;
    }
    rfidPending = false;
    rfidMode = "";
    if(typeof(tagId) != 'undefined')
    {
		lastTagId = tagId;
		fs_tag.lastRfid = lastTagId;
    }
    log("rfidRead called with lastTagId: "+lastTagId);
    //branching();
    //log("rfidRead called with transition set: "+rfidTransition);
    //if(rfidTransition != "") changePage(rfidTransition);
    if(typeof rfidReadSuccess === 'function') rfidReadSuccess(rfidTransition);
}

function gpsRead(latitude,longitude)
{
	log("gpsRead. latitude: " + latitude + " longitude: " + longitude);
	lastLatitude = latitude;
	lastLongitude = longitude;
	if(typeof gpsReadSuccess === 'function') gpsReadSuccess(gpsTransition);
}

function startCustomWebView(url)
{
    log("startCustomWebView. url: " + url);
    callC("startCustomWebView;"+url);
}

function customWebViewTransition(url)
{
    //url could include error or cancel
    log("customWebViewTransition url: " + url);
}

function stopCustomWebView()
{
    callC("stopCustomWebView");
}

function restart(){
    callC("restart");			
    changePage( "home");
}				
function takePhoto(){			
    callC('camera');
}

function takePhoto2(){			
    //callC('camera2');
    //callC("setCameraDefaultImage;google.png");
//    callC('camera3;front');
	callC('camera3');
    //setTimeout("testChangeImage();",5000);
}

function testChangeImage()
{
	 callC("changeCameraImage;yahoo.jpg");
	 setTimeout("testSnap()",4000);
}

function testSnap()
{
	callC("snapCameraPreview;");
}

function remotePhoto()
{
    callC('camera3');
}

function photoStatus(status){
    route("photoStatus");
    $("#displayPhotoStatus").html(status);
}

function purgeQueue(){
    callC("reloadCommon;{}");
    //callC("purgeQueue;{}");
}

function purgeQueueTop(){
    callC("purgeQueueTop;{}");
}

function invokeRefreshControl() {
    callC("invokeRefreshControl;{}");
}

function uploadLog(){
    callC("uploadLog;{}");
}

function uploadStats(){
    callC("uploadStats;{}");
}


function purgeLog(){
    callC("purgeLog;{}");
}

function getConfig(){
    callC("getConfig;{}");
}			

// photo functions
function takingPhoto(){
    // this function does nothing, but is called from c# code
    return;
}					

var processDisplayPicture = null;

function displayPicture(rotateCheck,path){
    log("displayingPicture: "+path+" rotateCheck: "+rotateCheck);
    currentPicture = path;
    if(typeof processDisplayPicture === 'function'){
     	processDisplayPicture(path);
     	return;
    }

    $(".displayPhoto").html("<img class='center' src='"+path+"' />");
    route('photoReview');
};

function displayPictureLoading(rotateCheck,path){
	log("displayingPictureLoading: "+path+" rotateCheck: "+rotateCheck);
	//setTimeout("callC('chromaRecall;');",100);
}

function rotatePhoto() {
    callC('rotatePhoto');			
}

function photoScanValidate(){
    if (photoScans > 0) {
        route('thanks');
    }else{
        jAlert('Please scan at least one badge','No Scan');
    }
}

function setRfidTransition(page){
    rfidTransition = page;
    log("setRfidTransition: "+page);
    rfidPending = true;
    rfidMode = 'tag';
    callC("setRfidPending");
}

var serialReadCallback = "";
var lastSerialMessage = "";

function enableSerialReads(callback){

	serialReadCallback = callback;
    log("enableSerialReads: ");
    serialPending = true;
    callC("enableSerialReads");
}

function serialReadSuccess(message){
	lastSerialMessage = message;
	log("serialReadSuccess. message: "+message+" serialReadCallback: "+serialReadCallback);
	if(typeof serialReadSuccess == "function"){
		serialReadCallback(message);
	}
}

function disableSerialReads(){
	log("disableSerialReads.");
	serialReadCallback = "";
	callC("disableSerialReads");
}

function setGPSTransition(page)
{
	gpsTransition = page;
	log("setGPSTransition: " + page);
	callC("setGPSPending;");
}

function sendCheckin(){
    callC("sendCheckin");
}

function acceptToken(token){
    guestToken = token;
    if(typeof(receivedToken)=='function') receivedToken(guestToken);
}

function generateToken(){
    guestToken = "";
    callC("generateToken");
}

function writeFile(filename,content){
    c = new Object();
    c.filename = filename;
    c.content = content;
    c = JSON.stringify(c);
    if(typeof Android !== 'undefined') Android.callC("writeFile;"+c);
}

function appendFile(filename,content){
    c = new Object();
    c.filename = filename;
    c.content = content;
    c = JSON.stringify(c);
    if(typeof Android !== 'undefined') Android.callC("appendFile;"+c);
}

function readFile(filename,func){
    callbackForReadFile = func;
    c = new Object();
    c.filename = filename;
    c = JSON.stringify(c);
    if(typeof Android !== 'undefined') Android.callC("readFile;"+c);
}

function readFileCallback(content){
    if(typeof(callbackForReadFile)=='function') callbackForReadFile(content); else log("read file callback with no function registered");
    //callbackForReadFile = null;
}

function deleteFile(filename){
    c = new Object();
    c.filename = filename;
    c = JSON.stringify(c);
    if(typeof Android !== 'undefined') Android.callC("deleteFile;"+c);
}

function sendIntegration(url,type,header,data,timeout){

    c = new Object();
    c.type = type;
    c.url = url;
    c.data = data;
    c.header = header;
    c.timeout = ""+timeout;
    c = JSON.stringify(c);
    Android.callC("sendIntegration;"+c);

}

function saveEventConfig(data) {
    var temp = {};
    for (var key in data) {
        temp[key] = data[key];
    }
    for(var key in eventData) {
        temp[key] = eventData[key]
    }
    var args = JSON.stringify(temp);
    Android.callC("saveConfig;"+args);
}


function sendCommand(command, arguments, callback){
	setTimeout(sendCommand2,100,command,arguments,callback);
}

function sendCommand(command,arguments,callback){
    var cmd = new Object;
    cmd.command = command;
    cmd.arguments = JSON.stringify(arguments);
    if (callback) {
        if (typeof(callback)!== "string") {
            cmd.callback = callback.name;
        } else {
            cmd.callback = callback;
        }
    } else {
        cmd.callback = "";
    }
    cmd = JSON.stringify(cmd);
    Android.callC("sendCommand;"+cmd);	
}



/* function loadingMessage is used to alert a message
   in the event of an AJAX call, for instance.  Messages
   need to be cleared with the clearLoadingMessage function */
function loadingMessage(message) {
   try
   {
   	var dfd = new $.Deferred();
    $('#loading-message').text(message);
    $('#loading').show();
    return dfd.resolve();
   }
    catch(err)
    {
    log("loadingMessage error: " + err.toString());
    }
}

/* function clearLoadingMessage is used to clear messages
   initiated by function loadingMessage */
function clearLoadingMessage() {
    $('#loading').hide();
}

/* function alertError is used by C# side to alert errors */
function alertError(data) {
    $('#loading').hide();
    alert(data);
}

/* function checkForUpdate is used by panel to initiate and
   check for an update of the server config, and redownload zip
   if needed */
function checkForUpdate() {
    loadingMessage('Checking for update...');
    Android.callC('checkForUpdate;{}');
}
function vibrate(time) {
    var args = { "time" : time }
    callC('vibrate;'+JSON.stringify(args));
}

// Barcode Enable/Disable
function barcodeEnabled(){
    callC('loadApk;{"filename":"Scanner.apk"}');
};

function minimeEnabled(){
	callC('loadApk;{"filename":"minime.apk"}');
}

function testBarcode(){
    callC('testBarcodeEnabled;{"filename":"Scanner.apk"}');
}

function barcodeDisabled(){
    callC('deleteApk;{"filename":"Scanner.apk"}');
};

// The following are functions for handling the bootstrap layer,
// updating configs, etc.  All andy function are included.
window.andy = {};

andy.pullServerConfiguration = {
    go: function(args) {
            this.dfd = new $.Deferred();
            if (typeof(args) === "string") {
                callC('pullServerConfiguration;' + args);
            } else {
                args = JSON.stringify(args);
                callC(command + ';' + args);
            }
            return this.dfd.promise();
        },
    callback: function(response) {
                  configurationFile = response['result'];
                  return this.dfd.resolve();
              }
}

andy.getServerConfigurationHash = {
    go: function(args) {
            this.dfd = new $.Deferred();
            if (typeof(args) === "string") {
                callC('getServerConfigurationHash;' + args);
            } else {
                args = JSON.stringify(args);
                callC(command + ';' + args);
            }
            return this.dfd.promise();
        },
    callback: function(response) {
                  eventData["configuration_hash"] = response['result'];
                  return this.dfd.resolve();
              }
}

andy.initClient = {
    go: function(args) {
            this.dfd = new $.Deferred();
            callC('initClient;'+args);
            return this.dfd.promise();
        },
    callback: function(){
    	afterInitClient();
    }
}

andy.getZip = {
    dfd: null,
    go: function(zip) {
            this.dfd = new $.Deferred();
            if (!zip) {
                var zip = eventData["clientZip"];
            }
            var args = {};
            args.clientZip = zip;
            args = JSON.stringify(args);
            callC("getZip;"+args);
            return this.dfd.promise();
        },
    callback: function(response) {
                  return this.dfd.resolve();
              }
}

andy.getZipHash = {
    go: function() {
            this.dfd = new $.Deferred();
            var zip = eventData["clientZip"];
            callC("getZipHash;{\"file_path\":\""+zip+"\"}");
            return this.dfd.promise();
        },
    callback: function(response) {
                  eventData["clientZip_hash"] = response;
                  return this.dfd.resolve();
              }
}

andy.saveConfig = {
    go: function() {
            this.dfd = new $.Deferred();
            var args = JSON.stringify(eventData);
            callC('saveConfig;'+args);
            return this.dfd.promise();
        },
    callback: function(event) {
                  /*for (var key in event) {
                    eventData[key] = event[key];
                    }*/
                	afterSaveConfig();
                  //return this.dfd.resolve();
              }
}

andy.updateZip = {
    dfd: null,
    go: function() {
        this.dfd = new $.Deferred();
        this.count = 0;
        callC('updateZip;{}');
        return this.dfd.promise();
    },
    callbackResolve: function() {
                         return this.dfd.resolve();
                     },	
    callbackReject: function() {
                        if(!autoRecon) jAlert("Client is Already on the latest build.");
                        return this.dfd.reject();
                    }
}

andy.returnToBootstrap = {
    go: function() {
            jConfirm('Return to bootstrap?','', function(confirm) {if (confirm)andy.returnToBootstrap.bootstrap();});
        },
    bootstrap: function() {
                   callC('returnToBootstrap;{}');
               }
}

// This variable stores the timeout for opening and closing the control panel when holding the menu icon
andy.panelControl = {
    timeout: null
}

// This variable is true at startup, and becomes false once refresh control successfully updates for the
// first time.
andy.refreshControl = {
	firstRun: true
}

function setFirstRun(){
	andy.refreshControl.firstRun = true;
	log("setting firstRun");
 } 

var autoRecon = false;

function reconfig(){
	autoRecon = true;
	andy.updateZip.go();
}

function updateNotification() {
	log('update available, showing update bubble.');
	$('.updateNotification').show();
}
