log("--- cart.js loaded ---");
var cartScript;
var notVisible = false;

function sqliteOpenDB()
{
   var jsonArray = {};
   jsonArray['filename'] = "catalogData.sqlite";
   jsonArray['callback'] = "sqliteOpenDBDone";
   setTimeout(function(){callC("sqliteOpenDB;"+JSON.stringify(jsonArray))}, 100);
   log('loading db');
}

function sqliteOpenDBDone(result)
{
   log("sqliteOpenDBDone: " + result);
}

var queryType,lastItemID, paging = false, searchValue, category, manufacturer, limitNum = 5;

function fetchData(){
		
	if (barcoding === true){
		if(lastTagId === ''){
			setTimeout(function(){route('shopPage')}, 500);
			barcoding = false;
			return;
		}
		log(lastTagId);
		searchValue = parseInt(lastTagId, 10);

	}else{
		log('partName = '+$('.partName').prop( "checked" ) );
		log('Barcodenum = '+$('.Barcodenum').prop( "checked" ) );
		if ($('.partName').prop( "checked" ) === true || $('.Barcodenum').prop( "checked" ) === true){
			searchValue = $('#line').val();
			if ($('.Barcodenum').prop( "checked" ) === true){
				searchValue = parseInt($('#line').val(), 10);
			}
		}else{
			searchValue = $('#line').val().toUpperCase().replace(/ /g,'');
			log('searchValue = '+searchValue);
		}

	}
	var query = '';
	
	if (/^[A-Z]+$/.test(searchValue) === true){ 
		log('ALPHA');
		queryType = 'alpha';
		query = "SELECT *  FROM catalog WHERE Line LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
    } else if (/^[0-9]+$/.test(searchValue) === true){
    	log('NUMERIC');
    	queryType = 'numeric';
	    query = "SELECT * FROM catalog WHERE PartNumber LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
    }else if (/^[A-Z0-9]+$/.test(searchValue) === true){
    	log('BOTH');
    	queryType = 'both';
    	query = "SELECT *, (Line||PartNumber) AS Searchable FROM catalog WHERE Searchable LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
    }
	if ($('.partName').prop( "checked" ) === true){
		queryType = 'productName';
		query = "SELECT *  FROM catalog WHERE LongPartDescription LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
	}
	if (barcoding === true || $('.Barcodenum').prop( "checked" ) === true){
		queryType = 'barcoding';
		query = "SELECT *  FROM catalog WHERE BarcodeId = '"+searchValue+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
		barcoding = false;
	}
	$('#partName').attr('checked', false);
	$('#Barcodenum').attr('checked', false);
	
	log('queryType = '+queryType);
	log('query '+query);
    var jsonArray = {};
   	jsonArray['query'] = query;
   	jsonArray['callback'] = "creatResultList";
   	setTimeout(function(){callC("sqliteRunQuery;"+JSON.stringify(jsonArray))}, 10);    
   	log('done with list');
}

function pageDownData(){
	var query;
	log('lastItemID = '+lastItemID);
	if (queryType === 'barcoding'){
		return;
	}
	if (queryType === 'alpha'){ 
		log('ALPHA');
		queryType = 'alpha';
		query = "SELECT *  FROM catalog WHERE Line LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    } else if (queryType === 'numeric'){
    	log('NUMERIC');
    	queryType = 'numeric';
	    query = "SELECT * FROM catalog WHERE PartNumber LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    } else if (queryType === 'both'){
    	log('BOTH');
    	queryType = 'both';
    	query = "SELECT *,(HQLine||PartNumber) AS itemID, (Line||PartNumber) AS Searchable FROM catalog WHERE Searchable LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    } else if (queryType === 'category'){
    	log('category');
    	queryType = 'category';
    	if (manufacturer != ''){
    		if (category === ''){
    			query = "SELECT * FROM catalog WHERE ManufacturerName = '"+manufacturer+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    		}else{
    			query = "SELECT * FROM catalog WHERE ManufacturerName = '"+manufacturer+"' AND Category = '"+category+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    		}
    	}else{
    		query = "SELECT * FROM catalog WHERE Category = '"+category+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
		}
    } else if (queryType === 'productName'){
    	log('productName');
    	queryType = 'productName';
	    query = "SELECT * FROM catalog WHERE LongPartDescription LIKE '%"+searchValue+"%' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') AND itemID>'"+lastItemID+"' ORDER BY LongPartDescription, itemID LIMIT  "+limitNum;
    }

    var jsonArray = {};
   	jsonArray['query'] = query;
   	jsonArray['callback'] = "creatResultList";
   	setTimeout(function(){callC("sqliteRunQuery;"+JSON.stringify(jsonArray))}, 10);
}

function fetchManufacturer(){
	var query;
	if (category === ''){	
		query = "SELECT DISTINCT ManufacturerName FROM catalog WHERE (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY ManufacturerName";
	}else{
		query = "SELECT DISTINCT ManufacturerName FROM catalog WHERE Category = '"+category+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY ManufacturerName";
	}
	var jsonArray = {};
   	jsonArray['query'] = query;
   	jsonArray['callback'] = "creatManufacturerList";
   	setTimeout(function(){callC("sqliteRunQuery;"+JSON.stringify(jsonArray))}, 10);
}

function creatManufacturerList(result){
	var items=[];
	$('.manufacturerList').html('');
	//log(JSON.stringify(result, null,'\t'));

	$.each(result, function (index, data) {
		//log(JSON.stringify(data, null,'\t'));
		items.push($('<li/>').text(data.ManufacturerName));
	});
	$('.manufacturerList').append.apply($('.manufacturerList'), items);
	
	$('.manufacturerList li').on('click', function(e){
		manufacturer = $(e.target).text();
		fetchCategoryData();
		log('manufacturer = '+manufacturer);
		log('category = '+category);
	});
	route('manufacturer');
}


function fetchCategories(){
	var query;
	query = "SELECT DISTINCT Category FROM catalog ORDER BY Category";
	var jsonArray = {};
   	jsonArray['query'] = query;
   	jsonArray['callback'] = "creatCategoryList";
   	setTimeout(function(){callC("sqliteRunQuery;"+JSON.stringify(jsonArray))}, 10);
}

function creatCategoryList(result){
	//log(JSON.stringify(result, null, '\t'));
	var items=[];
	$('.categoriesList').html('');
	$.each(result, function (index, data) {
		items.push($('<li/>').text(data.Category));
	});
	$('.categoriesList').append.apply($('.categoriesList'), items);
	
	$('.categoriesList li').on('click', function(e){
		category = $(e.target).text();
		fetchCategoryData();
		log('category = '+category);
	});
	route('categories');
}

function fetchCategoryData(){
	queryType = 'category';
	var query;
	if (manufacturer != ''){
		if (category === ''){
			query = "SELECT * FROM catalog WHERE ManufacturerName = '"+manufacturer+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
		}else{
			query = "SELECT * FROM catalog WHERE ManufacturerName = '"+manufacturer+"' AND Category = '"+category+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
		}

	}else{
		query = "SELECT * FROM catalog WHERE Category = '"+category+"' AND (EligibleState='' OR EligibleState='"+currentPerson['BusinessState']+"') ORDER BY LongPartDescription, itemID LIMIT "+limitNum;
	}
	var jsonArray = {};
   	jsonArray['query'] = query;
   	jsonArray['callback'] = "creatResultList";
   	setTimeout(function(){callC("sqliteRunQuery;"+JSON.stringify(jsonArray))}, 10);
}

var currentResult = [];
function creatResultList(result){
	//log(JSON.stringify(result, null,'\t'));
	$('.manufacturerFIlter').hide();
	$('#line').val('');
   	$('.partName').attr('checked', false);

	log('paging = '+paging);
	$('.loadmore').hide();
	
	if (paging === true){
		
		$.each(result, function (index, data) {
			log('new result');
			log(JSON.stringify(data, null, '\t'));
			currentResult.push(result[index]);
		});

	}else{
		currentResult = result;
	}
	//log(JSON.stringify(currentResult));
	if (result.length < 1){
		if (paging === false){
			$('.manufacturerFIlter').hide();
			$('.resultsList').html('');
			$('.resultsList').append('<div class="item center"><h2>No Items Found</h2></div>');
			setTimeout(function(){route('shopPage')}, 2000);
		}
	}else{
		if (queryType === 'category'){
			$('.category').text(category);
			$('.manufacturer').text(manufacturer);
			$('.manufacturerFIlter').show();
		}else{
			$('.manufacturerFIlter').hide();
		}
		$('.resultsList').html('');
		var lastIndex = currentResult.length - 1;
		log('lastIndex = '+lastIndex+' length = '+currentResult.length);
		lastItemID = currentResult[lastIndex].itemID;
		log('lastItemID = '+lastItemID);
		var items=[];
		// loop through result to build items
		$.each(currentResult, function (index, data) {
	    	// get index of result length
	    	html = '';
	  		html += '<div class="item">';
	  		html += '<img src="'+currentResult[index].ImageLink+'" class="thumb" alt="'+currentResult[index].LongPartDescription+'" data-index="'+index+'" />';
	  		html +=	'<div class="productDetails">';
	  		html += '<h1 class="title" data-index="'+index+'">'+currentResult[index].LongPartDescription+'</h1>';
	  		html += '<div><span class="label">PART NUMBER: </span><span class="productData partNumberDisplay">'+currentResult[index].Line+' '+currentResult[index].PartNumber+'</span></div>';
	  		html += '<div><span class="label">QUANITY MULTIPLES: </span><span class="productData quantityMultiples">'+currentResult[index].QuantityMultiples+'</span></div>';
	  		html += '<div><span class="label">MANUFACTURER: </span><span class="productData manufacturerId">'+currentResult[index].ManufacturerName+'</span></div>';
	  		html += '<h2 class="regPrice red price">$'+addCommas(currentResult[index].RegRed.toFixed(2))+'</h2>';
	  		html += '<h1 class="salePrice red price">$'+addCommas(currentResult[index].SaleRed.toFixed(2))+'</h1>';
	  		html += '<h2 class="regStore store price">$'+addCommas(currentResult[index].RegStore.toFixed(2))+'</h2>';
	  		html += '<h1 class="SaleStore store price">$'+addCommas(currentResult[index].SaleStore.toFixed(2))+'</h1>';
	   		html += '</div></div>';
	  		items.push(html);
	  		
		});
		$('.resultsList').append.apply($('.resultsList'), items);
		displayPricing();
		
		hideBrokenImg();
		$('#searchResults .title, #searchResults .thumb').on('click', function(e){
			itemIndex = $(e.target).attr('data-index');
			productDetail(currentResult[itemIndex]);
			log('itemIndex = '+itemIndex);
		});
		$('.loadmore').show();
		if (result.length < limitNum){
			$('.loadmore').hide();
		}
		notVisible = true;
	}
	if (paging === false){
		setTimeout(function(){route('searchResults')}, 100);
		paging = true;
	}
}

function clearQueryVars(){
	log('clearQueryVars');
	currentResult = {};
	paging = false;
	queryType = '';
	lastItemID = '';
}

function productDetail(item){
	$('#quantity').val('1');
	$('#productDetail .title').html(item.LongPartDescription);
	$('#productDetail .thumb').prop('src',item.ImageLink);
	$('#productDetail .partNumberDisplay').html(item.Line+' '+item.PartNumber);
	$('#productDetail .quantityMultiples').html(item.QuantityMultiples);
	$('#productDetail .manufacturerId').html(item.ManufacturerName);
	$('#productDetail .regPrice').html('$'+addCommas(item.RegRed.toFixed(2)));
	$('#productDetail .salePrice').html('$'+addCommas(item.SaleRed.toFixed(2)));
	$('#productDetail .RegStore').html('$'+addCommas(item.RegStore.toFixed(2)));
	$('#productDetail .SaleStore').html('$'+addCommas(item.SaleStore.toFixed(2)));
	$('#productDetail .moreInformation').attr('data-link', item.NAPAOnlinePageLink);
	if (item.quantity > 0){
		$('#quantity').val(item.quantity);
	}
	currentItem = item;
	displayPricing();
	hideBrokenImg();
	log('currentItem = '+ JSON.stringify(currentItem));
	route('productDetail');

	
	
}

function creatCartList(){
	// clear curent cartList
	$('.cartItemList').html('');
	//log("currentCart = "+JSON.stringify(currentCart, null, '\t'));
	if (currentCart.length < 1){
		log('no items');
		$('.cartItemList').append('<div class="cartItem center"><h2>No Items In Cart!</h2></div>');
		var cartTotal = 0;
		$('.myTotal').text(cartTotal);
		$('.shoppingCart').text('');
		$('.shoppingCart').hide();
	}else{
		// loop through result to build items
		$.each(currentCart, function (index, data) {
	    	// get index of result length
	    	
	  		var open = '<div class="cartItem">', close = '</div>', html = '';
	  		html +=	'<div class="cartDetails col1">';
	  		html += '<h1 class="title" data-index="'+index+'">'+currentCart[index].LongPartDescription+'</h1>';
	  		html += '<div><span class="label">PART NUMBER: </span><span class="productData partNumberDisplay">'+currentCart[index].Line+' '+currentCart[index].PartNumber+'</span></div>';
	  		// pricing
	  		html += '<span class="regPrice red price">$'+addCommas(currentCart[index].RegRed.toFixed(2))+'</span>';
	  		html += '<span class="salePrice red price">$'+addCommas(currentCart[index].SaleRed.toFixed(2))+'</span>';
	  		html += '<span class="RegStore store price">$'+addCommas(currentCart[index].RegStore.toFixed(2))+'</span>';
	  		html += '<span class="SaleStore store price">$'+addCommas(currentCart[index].SaleStore.toFixed(2))+'</span>';
	  		
	  		html += '<span class="label qty">QUANITY MULTIPLES: '+currentCart[index].QuantityMultiples+'</span>';  		
	  		html += '<span class="label qty">ORDER QUANITY: '+currentCart[index].quantity+'</span>';
	  		html += '</div>';
	  		html += '<div class="col2">';
	  		html += '<a class="edit btn" data-itemIndex="'+index+'">Edit QTY</a><a class="delete btn" data-itemIndex="'+index+'">Delete</a>';
	  		var myQuantityPrice = currentCart[index].quantityPrice;
	  		myQuantityPrice = addCommas(myQuantityPrice.toFixed(2));
	  		html += '<h2 class="cartPrice">$'+myQuantityPrice+'</h2>';
	  		html += '</div>';
	  		$('.cartItemList').append(open + html + close);
		});

		displayPricing();
		
		var cartTotal = 0;
		$.each(currentCart, function (index, data) {
			cartTotal = cartTotal + currentCart[index].quantityPrice;
		});
		cartTotal = addCommas(cartTotal.toFixed(2));
		$('.myTotal').text(cartTotal);
		
		hideBrokenImg();
		
		// edit functions
		$('.edit').on('click', function(){
			log('edit click');
			var myindex = $(this).attr('data-itemindex');
			productDetail(currentCart[myindex]);
		//	currentCart.splice(myindex,1);
	    });

	    // delete from cart
	    $('.delete').on('click', function(){
	    	log('delete click');
	    	var myindex = $(this).attr('data-itemindex');
	    	currentCart.splice(myindex,1);
	    	//log(JSON.stringify(currentCart));
	    	creatCartList();
	    	cartItemQuanity();
	    });
	}
}

function strikePrice(){
	log('striking price....')
	$('.fullprice').removeClass('fullprice');
	// strike price if there is sale price
	$('.salePrice , .SaleStore').each(function(){
		if($(this).text() != '$0'){
			log($(this).prev().addClass('fullprice'));
		}
		if ($(this).text() === '$0'){
			$(this).hide();
		}
	});
	log('strike complete...');
}

function addToCart(){
	var a = $('#addcartform').validationEngine('validate');
    log('a = '+a);
    if (a === true){
        currentItem.quantity = $('#quantity').val();
		currentItem.quantityPrice = quantityPrice(currentItem);
		
		log('UID = '+currentItem['itemID']);
		
		$.each(currentCart, function (index, data) {
			log('CUID = '+data['itemID']);
			if (currentItem['itemID'] === data['itemID']){
				log('updating item');
				currentCart[index]['quantity'] = currentItem['quantity'];
				currentCart[index]['quantityPrice'] = currentItem['quantityPrice'];
				currentItem = {};
			}
		});
		if ($.isEmptyObject(currentItem) === false){
			var exist = $.inArray(currentItem,currentCart);
			log('exist = '+exist);
			if (exist < 0){
				log('adding item');
				currentCart.push(currentItem);
				currentItem = {};
			}
		}

		$('#quantity').val('');
		cartItemQuanity();
		route('cart');
    }
}

function quantityPrice(item){
	var userType = currentPerson['AttendeeType'];
	var quantity = currentItem.quantity;
	var quantityPrice;
	log('quantityPrice userType = '+userType);
	if ( userType === 'Jobber' || userType === 'Store Owner'){
		log('in jobber or Store Owner');
		if (item.SaleStore != ''){
			log(item.SaleStore);
			quantityPrice = (item.SaleStore*item.QuantityMultiples)*item.quantity;
		}else{
			log(item.RegStore);
			quantityPrice = (item.RegStore*item.QuantityMultiples)*item.quantity;
		}
	}else{
		log('userType not Store or Jobber = '+userType );
		if (item.SaleRed != ''){
			log(item.SaleRed);
			quantityPrice = (item.SaleRed*item.QuantityMultiples)*item.quantity;
		}else{
			log(item.RegRed);
			quantityPrice = (item.RegRed*item.QuantityMultiples)*item.quantity;
		}
	}
	log('find quantityPrice = '+JSON.stringify(item));
	return quantityPrice;
}

function cartItemQuanity(){
	if (currentCart.length > 0){
		$('.shoppingCart').text(currentCart.length);
		$('.shoppingCart').show();
	}
}

function displayCartList(){
	log('cart = '+JSON.stringify(currentCart));
	log('numItems in cart = '+currentCart.length);
	creatCartList();
}

function displayPricing(){
	var userType = currentPerson['AttendeeType'];
	//log('userType = '+userType);
	
	switch (userType){
		case 'Store Owner':
			$('.store').show();
			strikePrice();
			return;
		case 'Jobber': 
			$('.store').show();
			strikePrice();
			return;
		case 'Dealer Customer':
			$('.red').show();
			strikePrice();
			return;
	}
}

function submitCart(){
    // temp function to switch server
    tempSwitchSever();

    var d = new Date();
    var args = new Object;
    args.CartDate = d;
    args.ParticipantId = currentPerson.ParticipantId;
    args['Password'] = currentPerson['Password'];

    var cart = JSON.stringify(currentCart);
    args['Cart'] =  escape(cart);
    setTimeout(function(){ sendCommand('submit_cart',args)}, 10);
    route('thanks');
}

function hideBrokenImg(){
	$('.thumb')
		.error(function(){
			$( this ).attr( "src", "img/missing.jpg" );
		})
		
}

function checkPassword(field, rules, i, options){
	log('checkpassword');
  	if (field.val() != currentPerson['Password']) {
     	// this allows the use of i18 for the error msgs
     	return "*Password not correct";
  	}
}


var visibleY = function(el){
    var top = el.getBoundingClientRect().top, rect, el = el.parentNode;
    do {
        rect = el.getBoundingClientRect();
        if (top <= rect.bottom === false)
            return false;
        el = el.parentNode;
    } while (el != document.body);
    // Check its within the document viewport
    return top <= document.documentElement.clientHeight;
};

// Stuff only for the demo
function attachEvent(element, event, callbackFunction) {
    if (element.addEventListener) {
        element.addEventListener(event, callbackFunction, false);
    } else if (element.attachEvent) {
        element.attachEvent('on' + event, callbackFunction);
    }
};

var loadProducts = visibleY(document.getElementById('loadmore'));

var update = function(){
    if (currentPage === 'searchResults'){
	    loadProducts = visibleY(document.getElementById('loadmore'));
	    if (loadProducts === true && notVisible === true){
	    	notVisible = false;
	    	log('-------loadProducts------> '+loadProducts);
	    	pageDownData();	
	    	setTimeout(function(){notVisible = true}, 2000);
	    }
	}

};
attachEvent(document, "scroll", update);
attachEvent(window, "resize", update);



//load the db
log( 'db = '+db);
if (db === undefined){
	log('loading db');
	sqliteOpenDB();
	db = 'loaded';
}else{
	log(db + '! six in the clip and one in the hole!');
}
