// This file fires off all relevant supporting functions
// for a given subapp
console.log('loading mode.js');

function initMode(mode) {
    log("initMode - starting with mode = "+mode);
    window.mode = mode;
    $('.cartImg, .searchIcon, .barcodeIcon').hide();
    // mode login
    if (mode === 'login') {
        
        currentPerson = {};
        loggedInPerson = {};
        $('.fullName').text('');
        if (typeof loginScript === 'undefined'){
            $.getScript('js/login.js');
        }
        $('#login').on('click', function(){
            log('validationEngine');
            var a = $('#loginform').validationEngine('validate');
            log('a = '+a);
            if (a === true){
                log('logging in....');
                my_login();
                $('#login').off();
            }else{
                $('.content').scrollTop(0);
            }
        });
        
        rfidReadSuccess = readBarcodePersonCallback;

        $('.scan').on('click', function(){
            barcoding = true;
            Android.callC("readBarcode");
            barcode_timer_init();
        });

        $('.requestPass').on('click', function(){
           // startCustomWebView('https://www.napadrives.com/ForgotPassword.aspx');
            callC("openBrowser;https://www.napadrives.com/ForgotPassword.aspx");
        });
    // mode order
    } else if (mode === 'order'){
        currentCart = [];
        if (typeof orderScript === 'undefined'){
            $.getScript('js/order.js');
        }
        
        rfidReadSuccess = readBarcodePersonCallback;

        $('.scan').on('click', function(){
            barcoding = true;
            Android.callC("readBarcode");
            barcode_timer_init();
        });

        $('#login').on('click', function(){
            log('validationEngine');
            var a = $('#loginform').validationEngine('validate');
            log('a = '+a);
            if (a === true){
                log('logging in....');
                my_order();
                $('#login').off();
            }
        });
        $('.requestPass').on('click', function(){
           // startCustomWebView('https://www.napadrives.com/ForgotPassword.aspx');
            callC("openBrowser;https://www.napadrives.com/ForgotPassword.aspx");
        });

    // mode shop
    } else if (mode === 'shop'){
        $('#partName').on('click', function(){
            $('#Barcodenum').attr('checked', false);
        });
        $('#Barcodenum').on('click', function(){
            $('#partName').attr('checked', false);
        });
        if (placingOrder === true){
            $('.page').prepend('<h3 class="orderName center">Ordering: '+currentPerson['BadgeFirstName']+' '+currentPerson['BadgeLastName']+'</h3>');
        }
        // set barcode scanning to product
        rfidReadSuccess = readBarcodeProductCallback;
        isLoggedIn();
        
        $('.moreInformation').on('click', function(){
            var link = $(this).attr('data-link');
           // startCustomWebView(link);
            setTimeout(function(){callC("openBrowser;"+link)}, 10);
        });
        $('.categories').on('click', function(){
            fetchCategories();
        });

        $('.allManufacturers').on('click', function(){
            category = '';
            fetchManufacturer();
            paging = false;
        });

        $('.manufacturerFIlter').on('click', function(){
            fetchManufacturer();
            paging = false;
        });

        $('.loadmore').on('click', function(){
            pageDownData();
        });

        log('db = '+db);
        if (db === undefined){
            
            $.getScript( "js/cart.js" )
              .done(function( loadDB, textStatus ) {
                log('ajax status = '+ textStatus );
              })
              .fail(function( jqxhr, settings, exception ) {
                log( "Triggered ajaxError handler. "+exception );
                log('ajax status = '+ textStatus );
            });
        }
        

        $('.addCart').on('click', function(){
            addToCart();
        });
            
        $('.continue').on('click', function(){
            if($.isEmptyObject(currentResult) === false){
                route('searchResults');
            }else{
                route('shopPage');
            }
        });

        $('.search').on('click', function(){
            log('validationEngine');
            var a = $('#searchform').validationEngine('validate');
            log('a = '+a);
            if (a === true){
                log('fetching....');
                fetchData();
            }
        });

        $('.submitCart').on('click', function(){
            log('validationEngine');
            var a = $('#cartform').validationEngine('validate');
            log('a = '+a);
            if (a === true){
                log('submitCart....');
                submitCart();
            }
        });

        $('#scan, .scan').on('click', function(){
            barcoding = true;
            Android.callC("readBarcode");
            barcode_timer_init();
        });


        $('.cartImg, .searchIcon, .barcodeIcon').show();
        $('.shoppingCart').hide();

    // mode capture
    }else if (mode === 'capture'){
        $('.seen').removeClass('seen');
        if (typeof lookup === 'undefined'){
            $.getScript('js/capture.js');
        }
        rfidReadSuccess = readBarcodePersonCallback;
        $('#email').on('focus', function(){
            $('.next').show();
        });

        $('.scan').on('click', function(){
            barcoding = true;
            Android.callC("readBarcode");
            barcode_timer_init();
        });
        
        $('.manual').on('click', function(){
            barcoding = false;
            var a = $('#leadform').validationEngine('validate');
            log('a = '+a);
            if (a === true){
                route('manualPage');
            }
        });
    // mode approver
    }else if (mode === 'approver'){
        if (typeof approverScript === 'undefined'){
            $.getScript('js/approver.js');
        }
        $('.updateCart').on('click', function(){
            validateMyForm();
        })
    // reports
    }else if (mode === 'reports'){
        if (typeof reportsScript === 'undefined'){
            log('---- loading reportsScript and Charts');
            $.getScript('js/reports.js')
                .done(function( loadDB, textStatus ) {
                log('ajax status = '+ textStatus );
              })
              .fail(function( jqxhr, settings, exception ) {
                log( "Triggered ajaxError handler. "+exception );
                log('ajax status = '+ textStatus );
            });
        }
        $('#Approved-report h2').on('click', function(){
             Pending = false;
             route('reports');
        });
        $('#Pending-report h2').on('click', function(){
             Pending = true;
             route('reports');
        });
        $('.pending, #pending').on('click', function(){
            route('Pending-report');
        });

        $('.approved, #approved').on('click', function(){
            route('Approved-report');
        });
        
        if (loggedInPerson['AttendeeType'] != 'Headquarters' ){
            $('.categoryA, .categoryP').hide();
            $('.btn').css('font-size', '80%');
        }

        $('.categoryA').on('click', function(){
            route('Category-approved');
        });

        $('.categoryP').on('click', function(){
            route('Category-pending');
        });
        
    // mode settings
    }else if (mode === 'settings'){
        if (placingOrder === true){
            $('.orderName').remove();
            currentCart = [];
        }
        placingOrder = false;
        isLoggedIn();
        showNavigation();
    }
    standardModeInit();
    log("initMode - done.");
}

function standardModeInit() {
    // temp function to switch server
    tempSwitchBack();
    // should be executed for every mode
    $('.homeIcon').show();

    // validate form if "GO" || "Enter" "Return" are pressed
    
    $('form').keydown(function() {
        if (event.which == 13) {
            event.preventDefault(); // donothing
            //validateMyForm();
        }
    });
    
    $('#fname, #lname').on('change', function(e){
        id = '#'+ $(e.target).attr('id');
        word = $(e.target).val();
        //console.log(id +' and '+ word)
        capitalizeName(word, id);
    });

    $('#settings .button').on('click', function() {
        var id = $(this).attr('id');
        if (id === 'expo'){
            if (isAndroid === true){
                setTimeout(function(){callC('launchActivity;com.quickmobile.ita.napaexpo2015');}, 10);
            }else{
                setTimeout(function(){callC("openBrowser;http://2015napaexpo.quickmobile.mobi/");}, 10);
            }
        }else if(id === 'signout'){
            jConfirm('If you log out and have a cart that contains items that have not been submitted, this cart will be lost. Do you still want to logout?','SIGN OUT?', function(confirm) {if (confirm)signOut();});
        }else{
            loadApp(id);
        }
    });

    $('#phone').change(function(){
        phoneToInt();
    });
    
    $('#email').change(function(){
        var email = $('#email').val();
        email = email.toLowerCase();
        $('#email').val(email);
    });

    if (isAndroid === true){
        $("input[type='text'],input[type='email'],input[type='tel'],input[type='password'],input[type='number'],textarea").on('focus', function(e){
            log("input repositioning function fired");
            var delta = $(this).position();
            log("delta.top = "+delta.top);
            setTimeout(function(){$('body').scrollTop(delta.top - 80);},500);
        });    
    }
    if (isAndroid === false){
        $(document).on('blur', 'input, textarea', function() {
            setTimeout(function() {
                window.scrollTo(document.body.scrollLeft, document.body.scrollTop);
            }, 0);
        });
    }
}

// Calls in genericModeInit get called only once on document ready
// of the entire app.
function genericModeInit() {
    tempSwitchSever();
    log('isAndroid = '+isAndroid);

    $('.header').append('<span class="cartImg"><a class="shoppingCart"></a></span>');
    $('.header').append('<a class="searchIcon"></a>');
    $('.header').append('<a class="homeIcon"></a>');
    $('.header').append('<a class="barcodeIcon"></a>');
    $('.header').append('<div class="fullName"></div>');

    $('.cartImg').on('click', function(){
        route('cart');
    });
    $('.homeIcon').on('click', function(){
        setTimeout(function () {clearFields();loadApp('settings')}, 10);
    });
    
    $('.barcodeIcon').on('click', function(){
        route('shopPage');
        setTimeout(function () {barcoding = true;Android.callC("readBarcode");barcode_timer_init();}, 10);
    });

    $('.searchIcon').on('click', function(){
        route('shopPage');
    });

    $('.changeBack').on('click', function(){
        route(previousPage);
    });

    $('.updateNotification').on('click', function() {
    	jConfirm('Update configuration?','', function(confirm) {if (confirm)andy.updateZip.go();});
    });
    
    document.addEventListener('touchstart', function(event) {
        var $target = $(event.target);
        if ($target.hasClass('btn')){
            $target.addClass('active');
        }
    }, false);
    
    document.addEventListener('touchend', function(event) {
        var $target = $(event.target);
        if ($target.hasClass('btn') ){
            $target.removeClass('active');
        }
    }, false);
    
    // reporting charts
    $.getScript('js/Charts.js');

    log('window size: '+$(window).width() + 'x' + $(window).height());
    log('document size: '+$(document).width() + 'x' + $(document).height());
}

function signOut(){
    loggedInPerson = {};
    currentCart = [];
    currentItem = {};
    currentPerson = {};
    clearFields();
    loadApp('login');
}

// success for pruduct scans
function readBarcodeProductCallback(){
    barcode_timmer_clear();
    log('fetching....');
    fetchData();
    //route('searchResults');
}

// success for pruduct scans
function readBarcodePersonCallback(){
    log(lastTagId);
    barcode_timmer_clear();
    if (mode === 'capture'){
            if(lastTagId === ''){
            setTimeout(function(){route('error-page')}, 500);
            barcoding = false;
            return;
        }else{
            branching();
        }
    }else if (mode === 'order') {
        if(lastTagId === ''){
            return;
        }else{
            $('#email').val(lastTagId);
            setTimeout(function(){my_order()}, 100);
        }
    } else if (mode === 'login'){
        $('#email').val(lastTagId);
    } else {
        log('im lost');
    }
    barcoding = false;
}

function isLoggedIn(){
    if($.isEmptyObject(loggedInPerson) === false){
        if (placingOrder === false){
            currentPerson = loggedInPerson;
        }
    }else{
        jAlert('Must be logged in.', 'Not Logged In');
        standardModeInit();
        clearFields();
        setTimeout(function(){loadApp('login')}, 400);
        return;
    }
}

function showNavigation(){
    $('#settings .button').hide();
    $('#expo, #signout').show();
    switch(loggedInPerson['AttendeeType']){
        case 'Dealer Customer':
            $('#shop').show();
            $('#order').show();
            $('#reports').show();
            return;
        case 'Store Owner':
            $('#shop').show();
            $('#approver').show();
            $('#reports').show();
            return; 
        case 'Exhibitor':
        case 'Vendor':
            $('#capture').show();
            $('#order').show();
            return;
        case 'Field':
            $('#approver').show();
            $('#reports').show();
            return;
        case 'Headquarters':
            $('#reports').show();
            return;
    }
}
var barcodeTimer = null;
function barcode_timer_init(){
    log('init barcode_timer');
    barcodeTimer = setTimeout(function(){callC('cancelReadBarcode');jAlert('No barcode was found. Try again or use manual entry.','BARCODE NOT FOUND')}, 20000);
}

function barcode_timmer_clear(){
    log('clear barcode_timer');
    clearTimeout(barcodeTimer);
}

function addCommas(x){
     var parts = x.toString().split(".");
    parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    return parts.join(".");
}

function tempSwitchSever(){
// switch server
    var server1 = 'https://napa-api-1243211995.us-east-1.elb.amazonaws.com';
    var server3 = 'https://test1-852292920.us-east-1.elb.amazonaws.com:80';
    var server2 = 'https://test-napa.fishsoftware.com';
    var server4 = 'https://napa.fishsoftware.com';

    eventData.HostUrl = server4+'/module/client/rpc';
    updateEvent();
    // end switch    
}

function tempSwitchBack(){
    // switch server back
   // eventData.HostUrl = 'http://test-napa.fishsoftware.com/module/client/rpc';
   // updateEvent();
    // end switch
}


