console.log("loading FSRfidSupport.js");

window.performance = window.performance || {};
performance.now = (function() {
    return performance.now       ||
        performance.mozNow    ||
        performance.msNow     ||
        performance.oNow      ||
        performance.webkitNow ||            
        Date.now  /*none found - fallback to browser default */
})();

/*var  tagmapping =  {
    "printed_badge_id": {
        "type": "string",
        "offset": 0,
        "count": 6
    },
    "first_name" : {
        "type":"string",
        "offset":6,
        "count":12
    },
    "last_name" : {
        "type":"string",
        "offset":18,
        "count":12
    },
    "test": {
        "type":"uint32",
        "offset":30
    },
    "rfid_initialized": {
        "type": "flag",
        "offset": 34,
        "bit_number": 0
    },
    "optus_waiver_complete": {
        "type": "flag",
        "offset": 34,
        "bit_number": 1
    },
    "sponsor_redeemed_date": {
        "type":"uint8",
        "offset":35
    },
    "tower_kia_gso2_date": {
        "type":"uint8",
        "offset":36
    },
    "tower_jc_opendining_date": {
        "type":"uint8",
        "offset":37
    }
};*/
var tagmapping = {"first_name":{"count":20,"type":"string","offset":4},"vehicles_driven":{"type":"uint32","offset":24},"Photo":{"type":"flag","bit_number":1,"offset":28},"magic_number":{"count":4,"type":"string","offset":0},"driver":{"type":"flag","bit_number":2,"offset":28},"guest_id":{"count":4,"type":"string","offset":33},"Facebook_optin":{"type":"flag","bit_number":0,"offset":28},"purchase_horizon":{"count":4,"type":"string","offset":29}};
//alert(tagmapping.magic_number.type);

function startReader(){
	callC("readerReconnect;");
	waitingForLowLevel = true;
}

var tagmapping = {"verification": {
	        "type": "flag",
	        "offset": 0,
	        "bit_number": 1
	    }, "count":{"count":1,"type":"uint8","offset":0}};

//alert(tagmapping.magic_number.type);

var rfidMode = "";
var blockStr = "";
var lastTag = "";
var lastEPC = "";
var zoneManagement = false;
var readPending = false;
var currentBlock = "";
var currentBlockIndex = 0;
var lastAntennaID = "";

var blocksArray = new Object();

var fs_tag = {

    typeSizeMap:  {'string': 1,'uint8': 1, 'uint16': 2, 'uint32': 4, 'flag': 1},
    cardType: "CARD_TYPE_1K",
    //	blockSize: 16, // bytes per block (mifare)
    blockSize: 4, // bytes per block (tag-it)
    //	first_block_offset: 1, // mifare
    first_block_offset: 0, // tag-it
    cacheSize: 1024,
    //	totalBlockCount: 64,
    totalBlockCount: 6,
    cache: new ArrayBuffer(1024),
    dirty: new Array(64),
    view: null,
    fields: null,
    blocks: [],
    map: null,
    lastRfid: null,
    holdField: null,
    holdVal: null,
    hold: false,
    holdPage: null,
    holdPrevVal: null,
    numberTapTowers: 10,
    writeStatus: false,
    readStatus: false,
    aliasCache: {},
    holdPrevValCache: {},
    holdCache: {},
    guardTimer: 0,
    guardRfid: "",
    readSetIncrement: false,
    monitorsStarted: false, /* Note 3 */
    checksumCache: new ArrayBuffer(4),
    checksumView: null,
    checksumSize: 1,

    init: function(map){
    	log("FSRfidSupport init");
    	this.blocks = [];
        this.view = new Uint8Array(this.cache);
        this.checksumView = new Uint8Array(this.checksumCache);
        this.decodeMap(map);
        this.clearCache();
        this.clearDirty();
        this.lastRfid = "";
        lastTagId = "";
        this.writeHold = false;
        this.readSetIncrement = false;
        if(!this.monitorsStarted && false){
        	flushFieldsCallbackMonitor();
        	readFieldsCallbackMonitor();
        }
        
        //var mapJSON = JSON.stringify(map);
 		//log("init map: " + mapJSON);

    },

    decodeMap: function(map){
		this.map = {};
		$.extend(this.map,map);
       //this.map = map;
       this.blocksForFields();
    },

    clearCache: function(){
        //log("fs_tag.clearCache = typeof(this.view): " + typeof(this.view));
        for(var i=this.cacheSize-1;i--;){
            this.view[i] = 0;
        }
        var val = this.view[16];
        //log("fs_tag.clearCache clear = typeof(this.view[16]): "+typeof(val));
     },

    clearDirty: function(){
        for(var i= this.totalBlockCount-1;i--;){
            this.dirty[i] = 0;
        }
    },
    setDirty: function(){
        for(var i= this.totalBlockCount-1;i--;){
            this.dirty[i] = 1;
        }
    },
    setAlias: function(field,alias){
    	this.aliasCache[alias] = field;
    },
    
    unalias: function(field){
    	var tf = field;
		if(typeof(this.aliasCache[field]) !== 'undefined') tf = this.aliasCache[field];
		return tf;
    },

    blocksForFields: function(){
             var keys = [];
             for(var key in this.map){
                 var keyblocks = [];
                 var tmp;
                 if(this.map.hasOwnProperty(key)){
                     //log(key+ " "+ this.map[key].type + " " + this.map[key].offset);
                     //				keys.push(key);
                     byteOffset = parseInt(this.map[key].offset);
                     this.map[key].byteOffset = byteOffset;
                     var count = 1;
                     if(typeof(this.map[key].count)!='undefined'){
                         count = parseInt(this.map[key].count);
                     }
                     
                     var numBytes = parseInt(this.typeSizeMap[this.map[key].type]) * count;
                     this.map[key].numBytes = numBytes;
                     firstBlock = Math.floor(byteOffset / this.blockSize);
                     //				firstBlock++; // classic 1k reserves the first block
                     this.map[key].firstBlock = firstBlock;

                     otherBlocks = Math.ceil((numBytes - (this.blockSize - byteOffset % this.blockSize)) / this.blockSize);
                     skipCount = 0;
                     for(var i= firstBlock; i<= firstBlock + otherBlocks; i++){
                         //					if(i + skipCount % 4 == 3) /* 4 blocks per sector with last block reserved */
                         //						skipCount++;
                         tmp = i+skipCount;
                         if(keyblocks.indexOf(tmp) == -1) keyblocks.push(tmp);
                         if(this.blocks.indexOf(tmp) == -1) this.blocks.push(tmp);
                         if(tmp > this.totalBlockCount) this.totalBlockCount = tmp;
                     }
                     this.map[key].blocks = keyblocks;
                     this.map[key].byteOffset = keyblocks[0] * this.blockSize + (byteOffset % this.blockSize);
                     //				log("for field: " + key + " setting byte offset " + this.map[key].byteOffset + " orig: " + byteOffset);
                 }
             }
         },
                     
    readFields: function(fields,nextPage){/// don't actually need specific fields at the moment - just read all in the map
            log("fs_tag.readFields for: "+nextPage);
            this.writeHold = false;
            this.hold = false;
            this.readStatus = false;
            p = new Object();
            p.nextPage = nextPage;
            p.blocks = this.getBlocksForFields(fields);
            p.hold = "";

                    p = JSON.stringify(p);
                    rfidTransition = nextPage;
                    log("fs_tag.readFields setting transition: " + rfidTransition);
                    rfidMode = "read";
                    blockStr = this.blocks.toString();
                    rfidPending = true;
                    //log("zoneManagement. " + zoneManagement);
                    if(!zoneManagement) callC("requestRfidBlockRead;"+p);
                     /* else readWriteTimeoutVar = setTimeout("readWriteTimeout();",zoneConfig["readWriteTimeout"]);*/
                },

    readFieldsWithHold: function(fields,nextPage){/// don't actually need specific fields at the moment - just read all in the map
            log("readFieldsWithHold for: "+nextPage);
            this.writeHold = false;
            this.readStatus = false;
            this.hold = true;
            this.holdVal = "callback";
            this.holdField = "callback";
            p = new Object();
            p.nextPage = nextPage;
            p.blocks = this.getBlocksForFields(fields);
            p.hold = this.hold;

                            p = JSON.stringify(p);
                            rfidTransition = nextPage;
                            log("readFields setting transition: " + rfidTransition);
                            rfidMode = "read";
                            rfidPending = true;
                            blockStr = p.blocks.toString();
                           
                            if(typeof zoneManagement == 'undefined' || !zoneManagement) callC("requestRfidBlockRead;"+p);
                    		else readWriteTimeoutVar = setTimeout("readWriteTimeout();",zoneConfig["readWriteTimeout"]);
                        },

    setRfidTransitionWithHold: function(page){
           rfidTransition = page;
           log("setRfidTransitionWithHold: "+page);
           callC("setRfidPendingWithHold");
       },  

    readFieldsWithSet: function(fields,nextPage,field,val){/// don't actually need specific fields at the moment - just read all in the map
           log("readFieldsWithSet for: "+nextPage);
			this.writeHold = false;
           this.holdField = fs_tag.unalias(field);
           this.holdVal = val;
           this.hold = true;

           p = new Object();
           p.nextPage = nextPage;
           p.blocks = this.getBlocksForFields(fields);
           p.hold = "hold";
           
           rfidMode = "read";
   	 		blockStr = this.blocks.toString();
    		rfidPending = true;

           p = JSON.stringify(p);
           rfidTransition = nextPage;
           log("readFields setting transition: " + rfidTransition);
           if(typeof zoneManagement == 'undefined' && !zoneManagement) callC("requestRfidBlockRead;"+p);
    		else readWriteTimeoutVar = setTimeout("readWriteTimeout();",zoneConfig["readWriteTimeout"]);
       },

    readFieldsCallback: function(tagId, blocks){
			log("readFieldsCallback: tagId: "+tagId+" blocks: "+blocks);
			if(this.writeHold){
				log("readFieldsCallback. read during a write hold - ignore");
				return;
			}
			if(tagId != "" && blocks != ""){
			    if(tagId == this.guardRfid){
			    	var etime = performance.now() - this.guardTimer;
			    	log("dup tag - checking guard time: "+etime);
			    	if((etime < 10000) && this.readSetIncrement){
			    		log("readFieldsCallback. detected rescan attempt");
			    		this.readFieldsWIthSetAndIncrementInitiate();
			    		return;
			    	}
			    }
                this.lastRfid = tagId;
                this.guardRfid = tagId;
                lastTagId = tagId;
                blockArray = blocks.split(",");
                var good = true;
                for(var i=0;i<blockArray.length;i++){
                	var tmp = blockArray[i].split("=");
                   // this.readBlockCallback(i,blockArray[i]);
                   var status = this.readBlockCallback(tmp[0],tmp[1]);
                   log("readBlockCallback  : "+status.toString());
                   if(status===false){
                   		good = false;
                   		break;
                   	}
                }
             } else good = false;
            this.readStatus = good;
            if(this.readStatus) this.readStatus = this.validateChecksum();
            log("readFieldsCallback readStatus: "+this.readStatus.toString());
            this.clearDirty();
            if(this.hold){
            	if(this.readStatus===true){
	                if(this.readSetIncrement){
	                	this.guardTimer = performance.now();
	        			this.processReadSetIncrementCallback();
	        			return;
	        		}
                    this.holdPrevVal = this.getField(this.holdField);
                    this.setField(this.holdField,this.holdVal);
                    this.flushFields(rfidTransition);
                } else{
                	this.guardTimer = 0;
                	log("readFieldsCallback error on read for hold - skip flush");
                	callC("setRfidStop;");
                	this.writeStatus = 'False';
                	setTimeout("rfidRead()",100);
                }
            } else {
                setTimeout("rfidRead()",100);
            }
            //		log("readFieldsCallback - magic number: "+ this.getField("magic_number") + "  tagid: " + tagId);
            //		log("readFieldsCallback - guest_id: "+ this.getField("guest_id") + "  tagid: " + tagId);
        },

    rfidRead: function(tagId){
          lastTagId = tagId;
          if(typeof(rfidReadHoldCallback) == 'function') rfidReadHoldCallback(rfidTransition);
          log("rfidRead in fs_tag called with transition set: "+rfidTransition);
          if(rfidTransition != "") changePage(rfidTransition);
          if(typeof(rfidReadSuccess) == 'function') rfidReadSuccess(rfidTransition);
      },

    getHoldValue: function(field){
    	  var tf = fs_tag.unalias(field);
	      if(this.hold && this.holdField == tf){
	          this.hold = false;
	          return this.holdPrevVal;
	      } else {
	          log("getHoldValue error: "+tf);
	      }
	  },

    setHold: function(){
         this.hold = true;
         this.holdField = "callback";
         this.holdVal = "callback";
     },

    readBlockCallback: function(blocknum, blockdata){
	  log("readBlockCallback entry blocknum: "+blocknum.toString()+ " blockdata: "+blockdata);
	  if(typeof(blockdata) === 'undefined' || blockdata === '' || blockdata === 'undefined'){
	    log("readBlockCallback error block: "+blocknum);
	    //alert('Trying to read blockdata with no tag mapping in the configuration. Add tagmapping to configuration.'+''+'BLOCKDATA UNDEFUNED');
	  	return false;
	  }
       //block = this.blocks[blocknum];
       //		skippedBlocks = Math.floor(block/4);
       //		byteOffset = (block - this.first_block_offset - skippedBlocks) * this.blockSize;
       block = blocknum; // testing
       byteOffset = block * this.blockSize;

       blockOffset = 0;
       		log("readBlockCallback: "+block+" "+byteOffset+" "+blockdata);
       var bend = byteOffset+this.blockSize;
       for(var i=byteOffset; i<bend; i++){
           this.view[i] = parseInt(blockdata.substr(blockOffset,2),16);
      			log(i.toString() + " " + this.view[i].toString() + " " + blockdata.substr(blockOffset,2));
           blockOffset += 2;
       }
       //		this.dumpBlocks();
       return true;
   },

    writeBlockString: function(blocknum){
      var out = "";
      var byte = blocknum * this.blockSize;
      log("writing starting: "+byte);
      for(var i=byte;i<byte+this.blockSize;i++){
          var val = this.view[i];
          var hval = val.toString(16);
          if(hval.length < 2) hval = "0" + hval;

          out += hval;
      }
      return out.toUpperCase();
  },

    flushFieldsCallback: function(callArg){
	     var tmp = callArg.split(';');
	     var tagId = tmp[0];
	     this.writeHold = false;
	     this.writeStatus = tmp[1];
	     if(this.writeStatus != "True") this.guardTimer = 0;
	     if(tagId != this.lastRfid && (this.lastRfid!="" && this.lastRfid!="")){
	     	 this.guardTimer = 0;
	         log("tag id mismatch - wrote tag: " + tagId + " tag read was: " + this.lastRfid);
	     }
	     this.lastRfid = tagId;
	     this.guardRfid = tagId;
	     lastRfid = tagId;
	     lastTagId = tagId;
	     log("flushFields: changing to: "+rfidTransition);
	     setTimeout("rfidRead();",100);
	 },

    setField: function(field,val){
 		field = fs_tag.unalias(field);
                  if(typeof(val)=='undefined'){
                      log("setField value error: undefined for: "+ field);
                      return;
                  }
                  if(typeof(this.map[field])=='undefined'){
                  	  var mapJSON = JSON.stringify(this.map);
                  	  log("setField map: " + mapJSON);
                      log("setField name error: "+ field);
                      return;
                  }
                  log("setField: " + field + " val: " + val.toString());
                  offset = this.map[field].byteOffset;
                  numBytes = this.map[field].numBytes;
                  var blocks = this.map[field].blocks;
                  for(var i=0;i<blocks.length;i++){
                      this.dirty[blocks[i]] = 1;
                  }
                  switch(this.map[field].type){
                      case 'string':
                          for(var i=0;i<numBytes;i++){
                              if(i > val.length) bt = 0; else bt = val.charCodeAt(i);
                              this.view[offset+i] = bt;
                              if(field == "guest_id") log("tag setting field at: "+(offset+i).toString() + " val: " + bt + " view: " + this.view[offset+i]);
                          }
                          return;
                      case 'uint8':
                          ival = typeof(val)=='string' ? parseInt(val) : val;
                          this.view[offset] = ival;
                          log("setField. offset: " + offset + " ival: "+ival);
                          return;
                          
                      case 'uint32':
                      	  ival = typeof(val)=='string' ? parseInt(val) : val;
                      	  this.view[offset] = ival & 0xff;
                      	  log("setField. offset: " + offset + " ival: "+this.view[offset]);
                      	  this.view[offset+1] = (ival >>> 8) & 0xff;
                      	  log("setField. offset: " + (offset+1) + " ival: "+this.view[offset+1]);
                      	  this.view[offset+2] = (ival >>> 16) & 0xff;
                      	  log("setField. offset: " + (offset+2) + " ival: "+this.view[offset+2]);
                      	  this.view[offset+3] = (ival >>> 24) & 0xff;
                      	  log("setField. offset: " + (offset+3) + " ival: "+this.view[offset+3]);
                      	  return;

                      case 'flag':
                          bit = parseInt(this.map[field].bit_number);
                          ival = typeof(val)=='string' ? parseInt(val) : val;
                          /*				ival2 = ival;
                                                        if(ival == 0) ival = 1;
                                                        ival = (ival & 1) << (7-bit);
                                                        tmp = this.view[offset];				
                                                        tmp2 = (~ival)&255;
                                                        tmp = (tmp & tmp2);
                                                        if(ival2 != 0) tmp = tmp | ival;*/
                          var tmp = 1 << bit;
                          var tmp2 = (this.view[offset] & (~tmp));
                          if(ival!=0) tmp2 = tmp2 | tmp;
                          this.view[offset] = tmp2;
                          log("tag setting flag at: "+ field+ " offset: "+ (offset).toString() + " bit: " + bit + " tmp: " + tmp.toString(16) + " val: "+ val.toString(16) + " ival: " + ival.toString(16) + " tmp2: " + tmp2.toString() + " view: " + this.view[offset].toString(16));
                          return;
                  }
              },

    getField: function(field){
		field = fs_tag.unalias(field);
                  if(typeof(this.map[field])=='undefined'){
                      log("getField name error: "+ field);
                      return;
                  }
                  log("getting field: "+field);
                  //		this.dumpBlocks();
                  offset = this.map[field].byteOffset;
                  numBytes = this.map[field].numBytes;
                  log("getField: type: "+this.map[field].type);
                  switch(this.map[field].type){
                      case 'string':
                          chars = '';
                          for(var i=0;i<numBytes;i++){
                              var val = this.view[offset+i];
                              if(field=="guest_id" || field=="barcode") log("--"+val.toString());
                              if(val == 0 || val < 32 || val > 126) break;
                              chars += String.fromCharCode(val);
                          }
                          if(field=="guest_id" || field=="barcode"){
                              log("getField: "+ offset.toString());
                              log("field: "+chars);
                          }
                          log("field val: "+chars);
                          return chars;
                      case 'uint8':
                          log("field val: "+ this.view[offset].toString());
                          return this.view[offset];
                          
                      case 'uint32':
                      	  var ival = this.view[offset];
                      	  //log("0: "+ival);
                      	  ival += this.view[offset+1]<<8;
                      	  //log("1: "+ival);
                      	  ival += this.view[offset+2]<<16;
                      	  //log("2: "+ival);
                      	  ival += this.view[offset+3]<<24;
                      	  //log("3: "+ival);
                      	  log("field val: "+ival+ " "+ ival.toString(16));
                      	  return ival;

                      case 'flag':
                          bit = parseInt(this.map[field].bit_number);
                          var ival = this.view[offset];
                          //				var scnt = 7-bit;
                          //				ival = ival >>> scnt;
                          ival = ival >>> bit;
                          ival &= 1;
                          log("getting " + field + " flag from offset: " + offset + " cache value: " + this.view[offset].toString(16) + " flag: " + bit + " value: " + ival.toString());
                          //				log("--- "+ this.view[offset].toString() );
                          //				this.dumpBlocks();
                          log("field val: " + ival.toString());
                          return ival;
                  }
              },

    dumpBlocks: function(){
                    log("----dumping from 16");
                    for(var i=16;i<48;i++){
                        var val = this.view[i];
                        log(i.toString() + " " + this.view[i].toString());
                        //			out += val.toString(16).toUpperCase();
                        //			log(out);
                    }
                    return
                },

    flushFields: function(nextPage){
                     //		this.dumpBlocks();
                     //		return;
                     this.writeStatus = 'False';
                     this.generateChecksum();
                     var writeblocks = [];
                     //for(var i=0;i<this.dirty.length;i++){
                     for(var i=0;i<this.blocks.length;i++){
                         if(this.dirty[i] == 1 || true){
                             writeblocks.push(i.toString() + "=" + this.writeBlockString(i));
                         }
                     }
                     if(writeblocks.length == 0){
                         log("request to flush to tag with no dirty blocks");
                         return;
                     }
                     p = new Object();
                     p.nextPage = nextPage;
                     p.blocks = writeblocks;

                     p = JSON.stringify(p);
                     
                     rfidMode = "write";
                     blockStr = writeblocks.toString();
                     rfidPending = true;

                     rfidTransition = nextPage;
                     log("flushFields setting transition: " + rfidTransition);
                     if(typeof zoneManagement == 'undefined' || !zoneManagement)  callC("requestRfidBlockWrite;"+p);
                        else readWriteTimeoutVar = setTimeout("readWriteTimeout();",zoneConfig["readWriteTimeout"]);
                     return;
                 },

	generateChecksum: function(){
		  if(typeof(this.map["checksum"])=='undefined') return false;
		  var checksum = 0;

		   for(var i=0; i < this.blocks.length-this.checksumSize; i++){
            checksum ^= this.view[i];
           }
           if(lastTagId != ""){
               var key = lastTagId;
               var ln = lastTagId.length;
               var s = 0;
               if(ln > 16){
                s = ln - 16;
                ln = 16;
                 key = lastTagId.substr(s,ln);
               } else key = lastTagId;
           	    var tag = parseInt(key,16);
           	    checksum ^= tag;
           }
           this.setField("checksum",checksum);
           return true;
	},

	validateChecksum: function(){
		  if(typeof(this.map["checksum"])=='undefined') return true;
		  var checksum = 0;
		   for(var i=0; i < this.blocks.length-this.checksumSize; i++){
            checksum ^= this.view[i];
           }
           if(lastTagId != ""){
               var key = lastTagId;
               var ln = lastTagId.length;
               var s = 0;
               if(ln > 16){
                s = ln - 16;
                ln = 16;
                 key = lastTagId.substr(s,ln);
               } else key = lastTagId;
           	    var tag = parseInt(key,16);
           	    checksum ^= tag;
           }
           var savedChecksum = this.getField("checksum");
           log("validateChecksum: lastTagId: "+lastTagId+" checksum: "+checksum.toString());
           if(savedChecksum == checksum) return true; else return false;
	},
    
    sumAndClearTaps: function(){
                         var tp = "tap_tower_";
                         var sum = 0;
                         for(var i=1;i<=this.numberTapTowers;i++){
                             var tps = tp+i.toString();
                             var a = this.getField(tps);
                             sum += a;
                             this.setField(tps,0);
                         }
                         log("returning tap sum: "+sum);
                         return sum;
                     },

	getBlocksForFields: function(fields){
			var blocks = this.blocks;
			log("getBlocksForFields. "+JSON.stringify(fields));
			if(fields != ""){
				var blocks = [];
				$.each(fields,function(index,field){
					//log("getBlocksForFields. "+field+" typeof: "+typeof(field));
					var f = fs_tag.unalias(field);
					//log("getBlocksForFields. alias: "+field+" unalias: "+f);
					if(typeof(fs_tag.map[f]) === 'undefined'){
						//log("getBlocksForFields. warning usage of undefined field: "+f);
						return;//skip field
					}
					$.each(fs_tag.map[f].blocks,function(index,block){
						if(blocks.indexOf(block) == -1) blocks.push(block);
					});
				});
			}
			if(blocks.length == 0) blocks = this.blocks;
			return blocks;
	  },

    evaluateFieldsToTest: function(){
    	for(var i=0; i< this.holdCache.fieldsToTest.length; i++){
    		var testCondition = this.holdCache.fieldsToTest[i];
    		log("evaluateFieldsToTest. testCondition: "+testCondition);
    		var testSense = 0;
    		var splitVal;
    		if(testCondition.indexOf("!=") != -1){
    			testSense = 1;
    			splitVal = "!=";
    		}
			if(testSense == 0 && testCondition.indexOf("=") != -1){
				testSense = 2;
				splitVal = "=";
			}
			if(testCondition.indexOf(">=") != -1){
				testSense = 3;
				splitVal = ">=";
			}
			if(testSense == 0){
    			log("invalid wristband mapping: malformed test condition");
    			return false;
    		}    		
    		
    		var t = testCondition.split(splitVal);
    		var field = t[0];
    		field = fs_tag.unalias(field);
    		var value = t[1];
    		var v = fs_tag.getField(field);
    		var fieldSuccess = false;
    		
    		if(testSense == 2){
    			log("evaluateFieldsToTest. test equal: "+field+" to: "+value+" when is: "+v+" for field type: "+fs_tag.map[field].type);
	    		switch(fs_tag.map[field].type){
	              case 'string':
	              	if(v == value) fieldSuccess = true;
	              	break;
	              case 'uint8':
	                if(v == parseInt(value)) fieldSuccess = true;
	                break;
	              case 'uint32':
	                if(v == parseInt(value)) fieldSuccess = true;
	                break;
	              case 'flag':
	              	if(v == parseInt(value)) fieldSuccess = true;
	              	break;
	              default:
	              	fieldSuccess = false;
	             }
	        }
	        if(testSense == 1){
	        	log("evaluateFieldsToTest. test not equal: "+field+" to:"+value+" when is: "+v+" for field type: "+fs_tag.map[field].type);
	    		switch(fs_tag.map[field].type){
	              case 'string':
	              	if(v != value) fieldSuccess = true;
	              	break;
	              case 'uint8':
	                if(v != parseInt(value)) fieldSuccess = true;
	                break;
	              case 'uint32':
	                if(v != parseInt(value)) fieldSuccess = true;
	                break;
	              case 'flag':
	              	if(v != parseInt(value)) fieldSuccess = true;
	              	break;
	              default:
	              	fieldSuccess = false;
	             }
	        
	        }
	        if(testSense == 3){
	        	log("evaluateFieldsToTest. test greater than or equal: "+field+" to:"+value+" when is: "+v+" for field type: "+fs_tag.map[field].type);
	    		switch(fs_tag.map[field].type){
	              case 'uint8':
	              case 'uint32':
	                if(v >= parseInt(value)) fieldSuccess = true;
	                break;
	              default:
	              	fieldSuccess = false;
	             }
	        
	        }
             if(!fieldSuccess){
             	log("return false");
             	return false;
             }
    	}
 		log("returning success");
    	return true;
    },
   
    
    evaluateFieldsToSet: function(){
    	this.holdPrevValCache = {};
    	log("evaluateFieldsToSet. "+typeof(this.holdCache)+" "+typeof(this.holdCache.fieldsToSetifTestSuccess));
		for(var i=0; i< this.holdCache.fieldsToSetifTestSuccess.length; i++){
    		var setCondition = this.holdCache.fieldsToSetifTestSuccess[i];
    		log("evaluateFieldsToSet. setCondition: "+setCondition);
    		var setAction;
    		var splitVal;
    		if(setCondition.indexOf("+=") != -1){
    			setAction = false;
    			splitVal = "+=";
    		} else{
    			if(setCondition.indexOf("=") != -1){
    				setAction = true;
    				splitVal = "=";
    			} else{
	    			jAlert("invalid wristband mapping: malformed test condition");
	    			return;
	    		}
    		}
    		var t = setCondition.split(splitVal);
    		var field = t[0];
    		field = this.unalias(field);
    		var value = t[1];
    		var v = fs_tag.getField(field);
    		var fieldSuccess = false;
    		fs_tag.holdPrevValCache.field = fs_tag.getField(field);
    		
    		if(setAction){
    			fs_tag.setField(field,value);

	        } else{
	        	log("evaluateFieldsToSet. setCondition for increment: "+field+" val: "+value+ " previous type: "+typeof(fs_tag.holdPrevValCache.field));
	    		switch(fs_tag.map[field].type){
	              case 'string':
		           jAlert("invalid wristband mapping: malformed set condition - can't increment strings");
	    		   return;
	              case 'uint8':
	              case 'uint32':
	                var v2 = parseInt(value);
	                var v3 = fs_tag.holdPrevValCache.field;
	                var v4 = v2+v3;
	                log("incrementing: field: "+field+" increment: "+v2+" typeof increment: "+typeof(v2)+" previous: "+v3+" typeof previous: "+typeof(v3)+" new: "+v4);
	                fs_tag.setField(field,v4);
	                break;
	              case 'flag':
	                jAlert("invalid wristband mapping: malformed set condition - can't increment flags");
	    		   return;
	    		  default:
	    		   jAlert("invalid wristband mapping: malformed set condition - invalid field name: "+field);
	    		   return;
	            }   
	        }
    	}
    	log("preserve dict: "+JSON.stringify(fs_tag.holdCache.preserveDict));
		for (var field in fs_tag.holdCache.preserveDict)
		{
	     if (fs_tag.holdCache.preserveDict.hasOwnProperty(field)) {
	     	log("restore preservation: "+field+" val: "+this.holdCache.preserveDict[field]);
	    	fs_tag.setField(field,this.holdCache.preserveDict[field]);
	    	}
	    }
    },
    
    processReadSetIncrementCallback: function(){
    	if(this.evaluateFieldsToTest()){
    		this.evaluateFieldsToSet();
    		this.writeHold = true;
    		this.flushFields(rfidTransition);
    		return;
    	}
    	this.writeStatus = 'NA';
    	setTimeout("rfidRead()",100);
    },

       
    readFieldsWithSetAndIncrement: function(fieldsToRead,nextPage,fieldsToTest,fieldsToSetifTestSuccess,fieldsToPreserve){

	   var preserveDict = {};
	   if(typeof(fieldsToPreserve) !== 'undefined'){
	   	    for(var i=0; i< fieldsToPreserve.length; i++){
	   	      preserveDict[fieldsToPreserve[i]] = this.getField(fieldsToPreserve[i]);
    		}
	   }
	   
	   p = new Object();
	   p.nextPage = nextPage;
	   p.blocks = this.getBlocksForFields(fieldsToRead); // for temp compatibilty with lower layer
	   p.fieldsToRead = fieldsToRead;
	   p.fieldsToTest = fieldsToTest;
	   p.fieldsToSetifTestSuccess = fieldsToSetifTestSuccess;
//	   p.fieldsToPreserve = fieldsToPreserve;
	   p.hold = "hold"; // for temp compatibility with lower layer
	   p.preserveDict = preserveDict;
	   
	   this.holdCache = p;
	   this.readFieldsWIthSetAndIncrementInitiate();
	},
	
	readFieldsWIthSetAndIncrementInitiate: function(){
	   this.readStatus = false;
	   this.writeStatus = false;
	   this.hold = true;
	   this.readSetIncrement = true;
	   
	   var p = JSON.stringify(this.holdCache);
	   rfidTransition = nextPage;
	   log("readFields setting transition: " + rfidTransition);
	   callC("requestRfidBlockRead;"+p);
	},


   clearTag: function(nextPage){
		this.clearCache();
		this.setDirty();
		this.flushFields(nextPage);
     },                  



};

fs_tag.init(tagmapping);
//fs_tag.setField("magic_number","toyo");
//fs_tag.sumAndClearTaps();


var sessionFileLoopTime = 1000;
function readSessionFile()
{
   rfidReadSuccess = sessionAfterRead;
   readFile("session.json",sessionFileCallback);       
}
  
var sessionContext = "";
function sessionFileCallback(str)
{
  rfidReadSuccess = sessionAfterRead;
  var shouldContinue = false;
   if(str != "")
   {
   		var sessionJSON = jQuery.parseJSON(str);

   		var sessionID = sessionJSON["session_id"];
   		if(sessionID != "")
   		{
   			log("sessionFile: " + str);
	        if(sessionID == "terminate")
	        {
	          //writeFile("session.json","");
	          callC("deleteSessionFile");
	          callC("exit");
	          return;
	        }
   			sessionID = sessionID.split("-");
	   		var stationName = "";
	   		if(sessionID.length >= 2) stationName = sessionID[0] + "-" + sessionID[1] + "-" +  sessionID[2];// "3rdparty-" +
        	callC("changeStationName;"+stationName);
	   		sessionContext = "3rdparty|" + sessionID[3];

	   		//writeFile("session.json","");
        	callC("deleteSessionFile");

	   		setRfidTransition("");
   		}
   		shouldContinue = true;
   }
   else shouldContinue = true;

   if(shouldContinue) setTimeout("readSessionFile();",sessionFileLoopTime);
}

function sessionAfterRead()
{
   log("sessionAfterRead");
   var tagID = lastTagId;
   var visitorArray = {"tag_id":tagID};
   var visitorStr = JSON.stringify(visitorArray);
   writeFile("visitor.json",visitorStr);
   sendRecordVisit(tagID, sessionContext);
   readSessionFile();
}

var zoneConfig = new Object;
var zone = new Object;
var zoneTuneTags = [];
var zoneTuneAntennas = [];
var isTuning = false;
var lastTunePower;
var rfidPending = false;
var zoneStateHandler;
var zoneReadFinishedCallBack;
var lastShortUHFTag = "";
var lastShortUHFPower = "";
var lastShortHFTag = "";
var startedQueue = false;
var lowerLevelInit = false;
var waitingForLowLevel = true;

function waitForLowerLevelInit(){
//	log(".... waiting: "+waitingForLowLevel + " lower: "+lowerLevelInit);
	if(waitingForLowLevel && lowerLevelInit){
		log("detected request to restart rfid");
		waitingForLowLevel = false;
		setZoneConfig(zoneConfig);
		//startRFIDRead(true); (done in setZoneConfig)
		updateTagsHTMLLoop();
		lowLevelInit();//join with common code for lower level monitor
	}
	setTimeout("waitForLowerLevelInit();",500);
}

function enableZoneManagement()
{
	zoneManagement = true;
	callC("enableZoneManagement;");
	$(".mediaSection").hide();
	$(".zoneSection").show();
/*	startRFIDRead(true);
	updateTagsHTMLLoop();*/
	waitForLowerLevelInit();
	
	//ping();
}

var pingI = 0;
var pingCleared = false;
function ping()
{
	if(pingI == 100) return;
	callC("rfidSocketCommand;PING");
	if(pingCleared) log("ping failure");
	pingCleared = true;
	log("PING");
	pingI++;
	setTimeout("ping();",1000);
}

var shouldPopulateTags = false;
function toggleTagHTML(mode)
{
	if(mode == "tags" || mode == "tune") shouldPopulateTags = true;
	else shouldPopulateTags = false;
}

var shouldReadHF = false;
var hfReadLoop = false;
function hfRead()
{
	if(shouldReadHF)
	{
		//log("shouldReadHF...");
		callC("rfidSocketCommand;HF READ");
	}
	setTimeout("hfRead();",zoneConfig["hfReadSpeed"]);
}

function startRFIDRead(startRead)
{
	var activeAntennas = getActiveAntennasMux();
	var activeShortReach = getActiveHF();
	
	log("startRFIDRead. " + startRead + " activeAntennas: " + activeAntennas.length + " activeShortReach: " + activeShortReach.length);
	if(startRead)
	{
		if(activeAntennas.length > 0)
		{
			log("startRFIDRead - starting RFID AUTO and requesting going back to unselected tags");
			callC("rfidSocketCommand;SET SELECTDATALEN 0");
			//callC("rfidSocketCommand;SET READWORDCOUNT 2");
			//callC("rfidSocketCommand;SET ADDR 0");
			if(zoneConfig["enableUhfTest"]) callC("enableUhfTest;");
			callC("rfidSocketCommand;RFID AUTO");
		}
		else{
		 if(zoneConfig["enableUhfTest"]) callC("disableUhfTest;");
		 callC("rfidSocketCommand;RFID STOP");
		 }
		
		if(activeShortReach.length > 0)
		{
			log("startRfidRead - starting HF READs");
			//callC("rfidSocketCommand;HF READ");
			
			shouldReadHF = true;
			if(!hfReadLoop) 
			{
				hfRead();
				hfReadLoop = true;
			}
		}
		else shouldReadHF = false;
		//else callC("rfidSocketCommand;HF STOP");
	}
	else
	{
		callC("rfidSocketCommand;RFID STOP");
		shouldReadHF = false;
		//callC("rfidSocketCommand;HF STOP");
	}
}

function disableZoneManagement()
{
	zoneManagement = false;
	callC("disableZoneManagement;");
	$(".mediaSection").show();
	$(".zoneSection").hide();
}


function initialZoneConfig()
{
	log("setting initial zone config (defaults)");
	//do a check before this for a file
	var initialZoneConfigDict = new Object;
	
	var antennas = [];
	antennas.push({"muxPosition":1, "readPosition":"A1", "powerLevel": 0, "shortReach": false});
	antennas.push({"muxPosition":5, "readPosition":"A2", "powerLevel": 0, "shortReach": false});
	antennas.push({"muxPosition":13, "readPosition":"A4", "powerLevel": 15, "shortReach": true}); //desired for write: 13
	antennas.push({"muxPosition":"HF","readPosition":"HF", "powerLevel":"OFF","shortReach":true});
	//external
	antennas.push({"muxPosition":3, "readPosition":"C1", "powerLevel": 0, "shortReach": false});
	antennas.push({"muxPosition":7, "readPosition":"C2", "powerLevel": 0, "shortReach": false});
	
	initialZoneConfigDict["antennas"] = antennas;
	initialZoneConfigDict["exitTime"] = 60000;//bn test patch
	initialZoneConfigDict["useTID"] = false;
	initialZoneConfigDict["readWriteTimeout"] = 10000;
	initialZoneConfigDict["writeTimeoutCheck"] = 10000;//was 5000
	initialZoneConfigDict["hfReadSpeed"] = 500;
	initialZoneConfigDict["recordDwellVisits"] = false;
	initialZoneConfigDict["enableZoneManagement"] = true;
	initialZoneConfigDict["enableUhfTest"] = false;
	initialZoneConfigDict["testTagStart"] = 25133039;
	initialZoneConfigDict["testTagEnd"] = 25133420;
	initialZoneConfigDict["shortReachTestCount"] = 500;
	
	zoneConfig = initialZoneConfigDict;
	//setZoneConfig(initialZoneConfigDict);
}

function setZoneConfig(configDict)
{
	zoneConfig = configDict;
	var zoneConfigStr = JSON.stringify(zoneConfig);
	
	log("setting zone config: "+zoneConfigStr);
	if(waitingForLowLevel) return;
	
	var antennas = configDict["antennas"];
	var muxString = "";
	for(var i = 0; i < antennas.length; i++)
	{
		var antennaMux = antennas[i]["muxPosition"];
		var powerLevel = antennas[i]["powerLevel"];
		var shortReach = antennas[i]["shortReach"];
		
		if(powerLevel != 0 && antennaMux != "HF")
		{
			muxString += " " + antennaMux;
			if(shortReach && powerLevel != 0) setPowerLevel(antennaMux,powerLevel,true);
			else{
				if(powerLevel != 0) callC("rfidSocketCommand;SET ANTENNAPOWER " + antennaMux + " " + powerLevel + " 5");
			}
		}
		/*else if(antennaMux == "HF")
		{
			if(powerLevel == "ON") callC("rfidSocketCommand;HF AUTO");
			else callC("rfidSocketCommand;HF STOP");
		}*/
	}
	if(muxString != "")
	{
		muxString = "SET MUX" + muxString;
		log("setZoneConfig. muxString: " + muxString);
		callC("rfidSocketCommand;"+muxString);
		
		if(zoneConfig["useTID"])
		{
			log("useTID.");
			setReadTID();
		}
		
		log("setZoneConfig - setting to RFID AUTO");
	}
	startRFIDRead(true);
	
	zoneConfigHTML();
	writeFile("zone.cfg",zoneConfigStr);
	//log("setZoneConfig: " + zoneConfigStr);
}

var shortReachOn = false;

function onlyShortReachOn()
{
	log("onlyShortReachOn...: "+shortReachOn.toString());
	if(shortReachOn) return;
	var muxString = "";
	var antennas = zoneConfig["antennas"];
	var muxString = "";
	for(var i = 0; i < antennas.length; i++)
	{
		var antennaMux = antennas[i]["muxPosition"];
		var powerLevel = antennas[i]["powerLevel"];
		var shortReach = antennas[i]["shortReach"];
		
		if(shortReach && powerLevel != 0 && antennaMux != "HF")
		{
			muxString += " " + antennaMux;
			//setPowerLevel(antennaMux,powerLevel,true);
		}
/*		else if(powerLevel != 0 && antennaMux != "HF")
		if(powerLevel != 0 && antennaMux != "HF")
		{
			if(shortReach) setPowerLevel(antennaMux,powerLevel,true);
			else callC("rfidSocketCommand;SET ANTENNAPOWER " + antennaMux + " " + powerLevel + " 5");
		}*/
	}
	if(muxString != "")
	{
		muxString = "SET MUX" + muxString;
		log("onlyShortReach. muxString: " + muxString);
		shortReachOn = true;
		callC("rfidSocketCommand;"+muxString);
	}
}

function setReadTID()
{
	callC("rfidSocketCommand;SET MEMBANK TID");
	callC("rfidSocketCommand;SET ADDR 00");
	callC("rfidSocketCommand;SET READWORDCOUNT 4");
	callC("rfidSocketCommand;SET TAGMETADATA2 DATA");
}

function getActiveAntennasMux()
{
	var activeAntennas = [];
	var antennas = zoneConfig["antennas"];
	for(var i = 0; i < antennas.length; i++)
	{
		if(antennas[i]["powerLevel"] != 0 && antennas[i]["muxPosition"] != "HF") activeAntennas.push(antennas[i]["muxPosition"]);
	}
	return activeAntennas;
}

function getActiveAntennasArr()
{
	var activeAntennas = [];
	var antennas = zoneConfig["antennas"];
	for(var i = 0; i < antennas.length; i++)
	{
		if(antennas[i]["powerLevel"] != 0 && antennas[i]["muxPosition"] != "HF") activeAntennas.push(antennas[i]);
	}
	return activeAntennas;
}

function getActiveHF()
{
	var activeAntennas = [];
	var antennas = zoneConfig["antennas"];
	for(var i = 0; i < antennas.length; i++)
	{
		if(antennas[i]["powerLevel"] != "OFF" && antennas[i]["muxPosition"] == "HF") activeAntennas.push(antennas[i]);
	}
	return activeAntennas;
}

var lastMuxString = "";

function setPowerLevel(antennaMux, powerLevel,inSaveConfig)
{
	log("setPowerLevel. antennaMux: " + antennaMux + " powerLevel: " + powerLevel);
	if(powerLevel > 30) powerLevel = 30;
	else if(powerLevel < 5 && powerLevel != 0) powerLevel = 5;
	
	if(!inSaveConfig)
	{
		var antennas = zoneConfig["antennas"];
		for(var i = 0; i < antennas.length; i++)
		{
			if(antennas[i]["muxPosition"] == antennaMux)
			{
				antennas[i]["powerLevel"] = powerLevel;
				break;
			}
		}
	}
	
	if(!inSaveConfig)
	{
		zoneConfig["antennas"] = antennas;
		var zoneConfigStr = JSON.stringify(zoneConfig);
		writeFile("zone.cfg",zoneConfigStr);
	}
	
	if(powerLevel != 0 && antennaMux != "HF")
	{
		var readPower = powerLevel;
		//if(readPower >= 9) readPower =5;
		var powerStr = "SET ANTENNAPOWER " + antennaMux + " " + readPower + " " + powerLevel;
		callC("rfidSocketCommand;"+powerStr);
	}
	
	if(!inSaveConfig)
	{
		if(antennaMux == "HF")
		{
			/*if(powerLevel == "ON") callC("rfidSocketCommand;HF AUTO");
			else callC("rfidSocketCommand;HF STOP");*/
		}
		else
		{
			var activeAntennas = getActiveAntennasMux();
			if(activeAntennas.length > 0)
			{
				var activeAntennasStr = activeAntennas.join(" ");
				var muxString = "SET MUX " + activeAntennasStr;
				if(muxString != lastMuxString)
				{
					log("setPowerLevel. muxString: " + muxString);
					callC("rfidSocketCommand;"+muxString);
					log("setPowerLevel. setting to RFID AUTO");
					lastMuxString = muxString;
				}
			}
		}
		startRFIDRead(true);
	}
}

function setShortReach(antennaMux,shortReach)
{
	var antennas = zoneConfig["antennas"];
	for(var i = 0; i < antennas.length; i++)
	{
		if(antennas[i]["muxPosition"] == antennaMux)
		{
			antennas[i]["shortReach"] = shortReach;
			break;
		}
	}
	
	zoneConfig["antennas"] = antennas;
	var zoneConfigStr = JSON.stringify(zoneConfig);
	writeFile("zone.cfg",zoneConfigStr);
}

function readZoneConfig()
{
	readFile("zone.cfg",readZoneConfigProcess);
}

var lastZoneConfigUpdate = "";

function saveZoneConfig()
{
	try{
		var zoneConfigStr = JSON.stringify(zoneConfig);
		if(lastZoneConfigUpdate != zoneConfigStr){
			writeFile("zone.cfg",zoneConfigStr);
			lastZoneConfigUpdate = zoneConfigStr;
		}
	}
	catch(e){
		log("saveZoneConfig. while config not initialized: "+e.toString());
	}
	deleteOldInactiveTags();
	setTimeout("saveZoneConfig();",5000);
}

function readZoneConfigProcess(cfgStr)
{
	log("readZoneConfigProcess. cfg: "+cfgStr);
	if(cfgStr != "" && cfgStr.indexOf("antennas")!=-1)
	{
		try
		{
			log("recovering previous zone config");
			var cfgArray = jQuery.parseJSON(cfgStr);
			setZoneConfig(cfgArray);
		}
		catch(e)
		{
			log("initializing zone config");
			initialZoneConfig();
		}
	}
	else initialZoneConfig();
	saveZoneConfig();
	readFile("zone.txt",readZoneArrayProcess);
}

function readZoneArrayProcess(zoneStr)
{
	if(zoneStr != "")
	{
		try
		{
			var zoneArr = jQuery.parseJSON(zoneStr);
			zone = zoneArr;
		}
		catch(e){}
	}
	//saveZoneConfig();
	if(typeof(zoneReadFinishedCallback) == 'function') zoneReadFinishedCallback(); 
}

function getAntennaByReadPos(readPosition)
{
	var antennas = zoneConfig["antennas"];
	for(var i = 0; i < antennas.length; i++)
	{
		if(antennas[i]["readPosition"] == readPosition) return antennas[i];
	}
}

var  tag =  {
    "barcode": {
        "type": "string",
        "offset": 0,
        "count": 8
    }
};

/*function readRfid(){
	//log3("");
	$("#lastrfdata").val("");
	$("#lastrf").val("");
	//callC("power;7");
	barcode = false;
	rfidWrite = false;
	fs_tag.init(tag);
	fs_tag.readFields("","");
	log("request to read rfid");
}

function writeRfid(){
	//$("#lastrfdata").val("");
	//$("#lastrf").val("");
	barcode = false;
	rfidWrite = true;
	fs_tag.init(tag);
	fs_tag.setField("barcode","12335678");
	fs_tag.flushFields("");
	log("request to write rfid");
}*/

var lastLargestBlock = 0;
function setBlock(blockIndex,mode)
{
	log("setBlock " + blockIndex + " " + mode) + " "+ writeFinished2.toString();
	log("setBlock. tagType: " + tagType);
	var blockKeys = Object.keys(blocksArray);
	var blockIndexKey = blockKeys[0];
	var blockIndexKeyArr = blockIndexKey.split("=");
	blockIndexKey = blockIndexKeyArr[0];
	var writeData = "";
	
	/*if(mode == "write")
	{
		var tmpBlockArr = blockIndexKey.split("=");
		var blockIndexKey = tmpBlockArr[0];
		var writeData = tmpBlockArr[1];
	}*/
	
/*	if(tagType == "UHF")
	{
		var selectInvert = "DISABLED";
		var selectMemBank = "EPC";
		var selectAddr = "4";
		var selectDataLen = "12";
		var selectData = lastTag;
		callC("rfidSocketCommand;SET TAGSELECT " + selectInvert + " " + selectMemBank + " " + selectAddr + " " + selectDataLen + " " + selectData);
	}*/
	
	var largestBlock = 0;
	var previousBlock = 0;
	for (var k in blocksArray)
	{
		if (blocksArray.hasOwnProperty(k)) 
		{
			var kArray = k.split("=");
			var blockNum = kArray[0];
			if(blockNum > largestBlock) largestBlock = blockNum;
			writeData += kArray[1];
			
			if(blockNum != 0 && previousBlock != (parseInt(blockNum) - 1))
			{
				log("blocks not contiguous...");
				writeFinished(lastTag,false);
				return;
			}
		}
	}
	
	lastLargestBlock = largestBlock;
	var wordCount = (parseInt(largestBlock) + 1) * 2;
	
	if(mode == "write" && !writeFinished2)
	{
		//log("initiating write...");
		writeCleared = false;
		if(blockIndexKey != 0) blockIndexKey++;
		var address = ("0" + blockIndexKey).slice(-2);
		
		var cmdArray = [];
		if(tagType == "UHF")
		{
			log("setting up for UHF write...");
			cmdArray.push("RFID STOP");
			//cmdArray.push("SET MEMBANK USER");
			//cmdArray.push("SET ADDR " + address);
			//cmdArray.push("SET READWORDCOUNT " + wordCount);
			//cmdArray.push("SET TAGMETADATA2 DATA");
			//cmdArray.push("SET WRITEDATA " + writeData);
			//cmdArray.push("RFID WRITE TAGDATA");
			var selectInvert = "DISABLED";
			var selectMemBank = "EPC";
			var selectAddr = "4";
			//var selectDataLen = "12";
			var selectDataLen = lastTag.length/2 + "";
			var selectData = lastTag;
			cmdArray.push("SET TAGSELECT " + selectInvert + " " + selectMemBank + " " + selectAddr + " " + selectDataLen + " " + selectData);
			cmdArray.push("RFID WRITE TAGDATA USER " + address + " " + wordCount + " " + writeData);
		}
		else
		{
			log("setting up for HF write...");
			address = blockIndexKey;
			var blockLength = 1;
			//cmdArray.push("HF STOP");
			shouldReadHF = false;
			cmdArray.push("HF WB " + address + " " + blockLength + " " + writeData);
		}
		
		var cmdString = cmdArray.join("%%");
		//log("setBlock. sending command: "+cmdString);
		callC("rfidSocketCommand;"+cmdString);
	}
	else if(mode == "read" || writeFinished2)
	{
		log("reading...");
		var cmdArray = [];
		if(tagType == "UHF")
		{
			var address = 00;//("0" + blockIndexKey).slice(-2);
			
			// use single block read defaults
			
/*			cmdArray.push("SET MEMBANK USER");
			cmdArray.push("SET ADDR 00");
			cmdArray.push("SET READWORDCOUNT " + wordCount);
			cmdArray.push("SET TAGMETADATA2 DATA");*/
			
			//syncrous
			/*cmdArray.push("RFID STOP");
			cmdArray.push("RFID READ TAGDATA USER " + address + " " + wordCount);*/
			//log("setBlock. read requesting going back to unselected tag");
			cmdArray.push("SET SELECTDATALEN 0");
		}
		else
		{
			var hfAddress = blockIndexKey;//("0" + blockIndexKey).slice(-2);
			var blockLength = 1;
			shouldReadHF = false;
			cmdArray.push("HF RB " + hfAddress + " " + blockLength);
		}
		
		var cmdString = cmdArray.join("%%");
		callC("rfidSocketCommand;"+cmdString);
	}
}

function rfidStopCheck()
{
	rfidStopCleared = false;
	callC("rfidSocketCommand;RFID STOP");
	callC("rfidSocketCommand;PING");
}

/*var uhfQueueArray = [];

function uhfAddToQueue(message)
{
	uhfQueueArray.push(message);
}

function uhfQueue()
{
	if(uhfQueueArray.length > 0)
	{
		var message = uhfQueueArray.shift();
		console.log("message: " + message);
		setTimeout(function() {uhfTagsFoundProcess(message);},100);
	}
	setTimeout("uhfQueue();",100);
}*/

function writeTimeoutCheck()
{
	if(!writeCleared)
	{
		log("write block timeout...");
		writeCleared = true;
		writeTimeout = true;
	}
}

var readWriteTimeoutVar;
function readWriteTimeout()
{
	if(rfidPending/* && readPending*/) 
	{
		log(rfidMode + " timeout.");
		if(rfidMode == "read")
		{
			var completedReadStr = "";
			for (var k in blocksArray)
			{
				if (blocksArray.hasOwnProperty(k)) 
				{
					var blockNum = k;
					completedReadStr += blockNum + "=" + "" + ",";
				}
			}
			if (completedReadStr.charAt(completedReadStr.length - 1) == ',') completedReadStr = completedReadStr.substr(0, completedReadStr.length - 1);
			readFinished(lastTag,completedReadStr);
		}
		else if(rfidMode == "write") writeFinished(lastTag,false);
		resetAfterReadWrite();
	}
}

function resetAfterReadWrite()
{
	clearTimeout(readWriteTimeoutVar);
	log("resetAfterReadWrite. with muxLocked: "+muxLocked.toString());
	//callC("rfidSocketCommand;RFID AUTO");
	readPending = false;
	rfidPending = false;
	rfidStopCleared = true;
	writeCleared = true;
	if(!zoneManagement) return;
	if(zoneConfig["useTID"]) setReadTID();
	//log("resetAfterReadWrite. requesting going back to unselected tags");
	callC("rfidSocketCommand;SET SELECTDATALEN 0");
	
	if(!muxLocked && shortReachOn){
	
		var antennas = zoneConfig["antennas"];
		var muxString = "";
		for(var i = 0; i < antennas.length; i++)
		{
			var antennaMux = antennas[i]["muxPosition"];
			var powerLevel = antennas[i]["powerLevel"];
			if(powerLevel != 0 && antennaMux != "HF") muxString += " " + antennaMux;
		}
		if(muxString != "")
		{
			muxString = "SET MUX" + muxString;
			log("resetAfterReadWrite. muxString: " + muxString);
			callC("rfidSocketCommand;"+muxString);
		}
		shortReachOn = false;
	}
	//setZoneConfig(zoneConfig);
	startRFIDRead(true);
}

function readFinished(tagID,readStr)
{
	clearTimeout(readWriteTimeoutVar);
	log("readFinished. tagID: " + tagID + " readStr: " + readStr + " lastAntennaID: "+lastAntennaID);
	fs_tag.readFieldsCallback(tagID,readStr);
	if(fs_tag.readStatus){
		if(lastAntennaID == "HF"){
			log("HF read success: " + tagID);
			counts.hfTagReads++;
		} else {
			log("shortReach write success: " + tagID);
			counts.shortReachTagReads++;
		}
	} else {
		if(lastAntennaID == "HF"){
			log("HF read error: " + tagID);
			counts.hfTagReadErrors++;
		} else {
			log("shortReach read error: " + tagID);
			counts.shortReachTagReadErrors++;
		}	
	
	}
}

function writeFinished(tagID,writeSuccess)
{	
	writeSuccessB = writeSuccess;
	writeSuccess = writeSuccess.toString();
	writeSuccess = writeSuccess.charAt(0).toUpperCase() + writeSuccess.slice(1);
	clearTimeout(readWriteTimeoutVar);
	log("writeFinished. tagID: " + tagID + " writeSuccess: " + writeSuccess + " lastAntennaID: "+lastAntennaID);
	fs_tag.flushFieldsCallback(tagID+";"+writeSuccess);
	if(writeSuccessB){
		if(lastAntennaID == "HF"){
			log("HF write success: " + tagID);
			counts.hfTagWrites++;
		} else {
			log("shortReach write success: " + tagID);
			counts.shortReachTagWrites++;
		}
	} else {
		if(lastAntennaID == "HF"){
			log("HF write error: " + tagID);
			counts.hfTagWriteErrors++;
		} else {
			log("shortReach write error: " + tagID);
			counts.shortReachTagWriteErrors++;
		}	
	
	}
	
}

function populateBlockArray(readStr)
{
	var blockKeys = Object.keys(blocksArray);
	if(blockKeys.length > 0)
	{
		for (var k in blocksArray)
		{
			if (blocksArray.hasOwnProperty(k)) 
			{
				var kArray = k.split("=");
				var blockNum = parseInt(kArray[0]);
				var blockReadStr = "";
				
				var startPos = blockNum * 8;
				var blockReadStr = readStr.substr(startPos,8);
				
				blocksArray[k] = blockReadStr;
			}
		}
	}
}

function processReadWrite(tagIDString,readStr)
{
	populateBlockArray(readStr);
	if(rfidMode == "write")
	{
		var writeSuccess = true;
		var completedReadStr = "";
		for (var k in blocksArray)
		{
		    if (blocksArray.hasOwnProperty(k)) 
		    {
		    	var kArray = k.split("=");
		    	var blockNum = kArray[0];
		        completedReadStr += blockNum + "=" + blocksArray[k] + ",";
		    }
		}
		
		if (completedReadStr.charAt(completedReadStr.length - 1) == ',') completedReadStr = completedReadStr.substr(0, completedReadStr.length - 1);
		if(completedReadStr != blockStr) writeSuccess = false;
		
		if(writeSuccess)
		{
			log("writeSuccess: " + writeSuccess + " blockStr: " + blockStr + " readStr: " + completedReadStr);
			writeFinished(tagIDString,writeSuccess);
			resetAfterReadWrite();
		}
		//else log("read after write failed. keep trying" + " blockStr: " + blockStr + " readStr: " + completedReadStr);
		
	}
	else if(rfidMode == "read")
	{
		var completedReadStr = "";
		for (var k in blocksArray)
		{
		    if (blocksArray.hasOwnProperty(k)) 
		    {
		    	var blockNum = k;
		        completedReadStr += blockNum + "=" + blocksArray[k] + ",";
		    }
		}
		if (completedReadStr.charAt(completedReadStr.length - 1) == ',') completedReadStr = completedReadStr.substr(0, completedReadStr.length - 1);
		readFinished(tagIDString,completedReadStr);
		resetAfterReadWrite();
	}
}

var muxLocked = false;

function lockMuxAfterRead(){
	muxLocked = true;
}

function unlockMux(){
	log("unlockMux.");
	muxLocked = false;
	resetAfterReadWrite();
}

var rfidStopCleared = true;
var writeCleared = true;
var writeTimeout = false;
var writeFinished2 = false;
//var messageCount = 0;

var tagType = "";

function toBin(str){
 var st,i,j,d;
 var arr = [];
 var len = str.length;
 for (i = 1; i<=len; i++){
                //reverse so its like a stack
  d = str.charCodeAt(len-i);
  for (j = 0; j < 8; j++) {
   arr.push(d%2);
   d = Math.floor(d/2);
  }
 }
        //reverse all bits again.
 return arr.reverse().join("");
}
function uhfTagsFoundProcess(messageReceived)
{
	//console.log(" message: " + messageReceived);
	if(!zoneManagement && false) return;
	//console.log(" message2: " + messageReceived);
	//messageCount++;
	var message;
	var messages = messageReceived.split("-%%-");
	for(var i5 = 0; i5 < messages.length; i5++)
	{
		message = messages[i5];
		if(message == "") continue;
		//console.log("uhfRawMessage: " + message);
		if(message.indexOf("@") == -1 && message.indexOf("BAUD") == -1)
		{
			if(message.indexOf("GET BAT") == -1 && message.indexOf("RFID TEMP") == -1 && message.indexOf("HEARTBEAT") == -1 && message.indexOf("HF READ") == -1) log("message: " + message);
			
			if(message.indexOf("BAT=")!=-1){
				try{
					var t = message.split("BAT=AC:");
					t = t[1].split(";");
					counts.batAC = parseInt(t[0]);
					
					t= message.split("1:");
					t = t[1].split(",");
					counts.battery1Charge = parseInt(t[0]);
					
					t= message.split("2:");
					t = t[1].split(",");
					counts.battery2Charge = parseInt(t[0]);
				} catch(e){
				
				}
				
				continue;
			}
			
			if(message.indexOf("RFID TEMP")!=-1){
				var t = message.split(",");
				var c = parseInt(t[1]);
				var f = Math.floor((c*1.8)+32);
				//counts.readerTemp = c.toString()+"/"+f.toString();
				counts.readerTemp = f.toString();
				continue;
			}
			
			if(writeCleared && (message.indexOf("RFID STOP") != -1 || message.indexOf("PING") != -1))
			{
				rfidStopCleared = true;
				if(readPending)
				{
					log("uhfTagsFoundProcess. setting to RFID AUTO");
					startRFIDRead(true);
				}
				
			}
			if(message.indexOf("No tags found" == -1) && (message.indexOf("Write Passed") != -1 || message.indexOf("Successful Block Write") != -1 || message.indexOf("RFID WRITE TAGDATA") != -1 || message.indexOf("HF WB") != -1))
			{
				log("write passed: " + message);
				var blockKeys = Object.keys(blocksArray);
				log("currentBlockIndex: " + currentBlockIndex + " " + (blockKeys.length-1));
				if(true)
				{
					writeFinished2 = true;
					writeCleared = true;
					startRFIDRead(true);
					currentBlockIndex = 0;
					setBlock(currentBlockIndex,"write");
				}
				
			}
			/*if(message.indexOf("Read Bytes:") != -1)
			{
				var readStr = message.split("Read Bytes:")[1];
				log("read block finished. result: " + readStr);
				processReadWrite(lastTag,readStr);
			}*/
			if((message.indexOf("RFID READ TAGDATA") != -1 || message.indexOf("HF RB") != -1) && message.indexOf("NACK") == -1)
            {
            	log("uhfTagsFound.. got tag read ack");
                var messageArr = message.split(",");
                var readStr = messageArr[messageArr.length-1];
                processReadWrite(lastTag,readStr);
            }
			continue;
		}
		
		if(!rfidStopCleared || !writeCleared) continue;
		
		//if(message.charAt(0) != "[") message = "[" + message.split("[")[1];
		//log("message: " + message);
		var msgArray = message.split("["); //,
		for(var i = 0; i < msgArray.length; i++)
		{
			var tagIDArray = msgArray[i].split("@");
			//log("testing2... id: "+ JSON.stringify(tagIDArray));
			if(tagIDArray.length >= 2) 
			{
				var tagIDArrayInner = tagIDArray[1].split(",");
				
				//var timeStamp = tagIDArray[0].replace("]","");
				var timeStamp = moment().format("YYYY-MM-DDTHH:mm:ss.SSS");
				
				var tagIDString = tagIDArrayInner[0];
				//log("testing.. "+tagIDString+" array: "+JSON.stringify(tagIDArray));
				
				var antennaID = tagIDArrayInner[1];
				
				var powerLevel = tagIDArrayInner[3];
				if(powerLevel == "255" && antennaID == "A1") antennaID = "HF";
				if(powerLevel.length > 2) powerLevel = powerLevel.substring(0,2);
				var shortReach = getAntennaByReadPos(antennaID)["shortReach"];
				
				var tidString = tagIDArrayInner[tagIDArrayInner.length - 1];
				if(zoneConfig["useTID"] && tidString != "" && !readPending)
				{
					 tagIDString = tidString;
					 lastEPC = tagIDArrayInner[0];
				}
				
				//if(readPending) tagIDString = lastTag;
				//lastTag = tagIDString;
				
				//if(readPending) lastTag = tagIDString; /// david question
				
				if(shortReach)
				{
					if(antennaID == "HF") lastShortHFTag = tagIDString;
					else{
						//log("updating lastShortUHFTag for Antenna: "+antennaID+ " epc id: "+tagIDString+" using: "+message);
						if(parseInt(powerLevel) < 75) continue;
						lastShortUHFTag = tagIDString;
						lastShortUHFPower = powerLevel;
						if(parseInt(powerLevel) < 75) continue;
					}
					lastAntennaID = antennaID;
					//updateLastShortHTML();
					
					if(rfidPending)
					{

						if(rfidMode == "tag" || ( (rfidMode == "read" || rfidMode == "write") && blockStr != "" && !readPending)){
							if(antennaID == "HF"){
//								log("HF: " + tagIDString+" in mode: "+rfidMode);
								counts.totalHfTagActivations++;
							} else {
//								log("shortReach: " + tagIDString + " in mode: "+rfidMode + " blockStr: "+blockStr+ " lastTag: "+fs_tag.lastRfid);
								counts.totalShortReachTagActivations++;
							}
						}

						if(rfidMode == "tag")
						{
							log("uhfTagsFoundProcess. got tag in tag mode: "+tagIDString);
							rfidRead(tagIDString);
						}
						else if((rfidMode == "read" || rfidMode == "write") && blockStr != "")
						{
							log("uhfTagsFoundProcess. got tag in mode: "+rfidMode+ " tagId: "+tagIDString+" readPending: "+readPending+" writeFinished2: "+writeFinished2+" lastRfid: "+ fs_tag.lastRfid + " rfidStopCleared: "+ rfidStopCleared);
					
							if(tagIDString != fs_tag.lastRfid &&  rfidMode == "write") continue;
							if(!readPending)
							{
								log("starting... blockStr: " + blockStr);
								tagType = "UHF";
								if(antennaID == "HF") tagType = antennaID;
								var tmpBlocksArray = blockStr.split(",");
								blocksArray = new Object();
								for(var i2 = 0; i2 < tmpBlocksArray.length; i2++)
								{
									var blockID = tmpBlocksArray[i2];
									blocksArray[blockID] = "";
								}
								currentBlockIndex = 0;
								readPending = true;
								writeFailed = false;
								writeFinished2 = false;
								
								log("tagType: " + tagType);
								if (tagType == "UHF" && rfidMode == "write") onlyShortReachOn();
								lastTag = tagIDString;
								setBlock(currentBlockIndex,rfidMode);
								//setTimeout("readWriteTimeout();",zoneConfig["readWriteTimeout"]);
							}
							else if(rfidStopCleared)
							{
								var wantedRawLength = (parseInt(lastLargestBlock) + 1) * 8;
								var shouldContinue = true;
								if(lastEPC != tagIDArrayInner[0] && zoneConfig["useTID"]) shouldContinue = false;
								//log("1 " + shouldContinue);
								if(tagIDArrayInner[tagIDArrayInner.length - 1].indexOf(lastTag) != -1) shouldContinue = false;
								//log("2 " + shouldContinue);
								if(tagIDArrayInner[tagIDArrayInner.length - 1].indexOf(tagIDArrayInner[0]) != -1) shouldContinue = false;
								//log("3 " + shouldContinue);
								if(tagIDArrayInner[tagIDArrayInner.length - 1].length != wantedRawLength) shouldContinue = false;
								//log("3.5 "+ shouldContinue+" wantedRawLength: "+wantedRawLength+" tl: "+tagIDArrayInner[tagIDArrayInner.length - 1].length);
								if(rfidMode == "write" && writeFinished2 != true){
									//log("3.6 ");
									shouldContinue = false;
								}
								//log("4 " + shouldContinue);
								if(shouldContinue)
								{
									var writeFailed = false;
									var readStr = tagIDArrayInner[tagIDArrayInner.length - 1];
									log("readStr: " + readStr + " " + readStr.substr(8,8) + " " + readStr.length);
									processReadWrite(tagIDString,readStr);
								}
							}
						}
					}
				}
				
				//log(i+"tag: " + tagIDString + " time: " + timeStamp + " antenna: " + antennaID + " power: " + powerLevel + " shortReach: " + shortReach);

				
				/*if(shortReach && rfidPending)
				{
					
				}*/
				//if(shortReach && zoneTuneTags.indexOf(tagIDString) == -1 && shouldPopulateTags) $("#lastShortReach").val(tagIDString);
				if(!shortReach)
				{
					if(!(tagIDString in zone))
					{

						var newAntennaArr = {};
						var antennaArr = {};
						newAntennaArr["powerLevel"] = powerLevel;
						newAntennaArr["startTime"] = timeStamp;
						newAntennaArr["lastTime"] = timeStamp;
						antennaArr[antennaID] = newAntennaArr;
						zone[tagIDString] = {"activereported":false, "inactivereported":false, "antennas":antennaArr, "startTime": timeStamp, "lastTime": timeStamp};
						
						if(zoneConfig["useTID"]) zone[tagIDString]["epc"] = tagIDArrayInner[0];
					}
					else
					{
						var antennaArr = zone[tagIDString]["antennas"];
						if(antennaID in antennaArr)
						{
							antennaArr[antennaID]["powerLevel"] = powerLevel;
							antennaArr[antennaID]["lastTime"] = timeStamp;
						}
						else
						{
							var newAntennaArr = {};
							newAntennaArr["powerLevel"] = powerLevel;
							newAntennaArr["startTime"] = timeStamp;
							newAntennaArr["lastTime"] = timeStamp;
							antennaArr[antennaID] = newAntennaArr;
						}
						zone[tagIDString]["antennas"] = antennaArr;
						zone[tagIDString]["lastTime"] = timeStamp;
						
						if(zone[tagIDString]["inactivereported"] == true)
						{
							zone[tagIDString]["inactivereported"] = false;
							zone[tagIDString]["startTime"] = timeStamp;
						}
					}
					//log("adding to zone. message: "+message+" zone entry: "+JSON.stringify(zone[tagIDString]));
				}
			}
		}
	}
//	log("adding to zone. message: "+message+" zone entry: "+JSON.stringify(zone));
//	log("messageReceived: "+messageReceived);
	if(typeof(zoneStateHandler) == 'function') zoneStateHandler();
}

function getActiveTags(reportAll)
{
	return getTags("activereported",reportAll);
}

function getInactiveTags(reportAll)
{
	var tags = getTags("inactivereported",reportAll);
	//console.log("getInactiveTags after");
	return tags;
}

var activeTags = {};
function getTags(mode,reportAll)
{
	var reportedTags = {};
//	log("getTags. mode: " + mode + "reportAll: "+reportAll.toString() +" before: " + JSON.stringify(zone));
//	log("getTags. mode: " + mode + " reportAll: "+reportAll.toString());
	for(var tagIDString in zone)
	{
		if(tagIDString == "") continue;
		if(zone[tagIDString][mode] == false || reportAll) 
		{
			var tagInactive = isTagInactive(tagIDString);
			if(tagInactive && mode == "inactivereported")
			{
				//log("tagInactive....");
				var activeSet = true;
				if(mode == "inactivereported") activeSet = false;
				if(!reportAll){
					log("getTags. reporting inactive: "+tagIDString);
					zone[tagIDString]["activereported"] = activeSet;
					zone[tagIDString]["inactivereported"] = !activeSet;
				}
				reportedTags[tagIDString] = zone[tagIDString];
			}
			else if(!tagInactive && mode == "activereported")
			{
				//log("tagActive...");
				var activeSet = true;
				if(mode == "inactivereported") activeSet = false;
				if(!reportAll){
					log("getTags. reporting active: "+tagIDString);
					zone[tagIDString]["activereported"] = activeSet;
					zone[tagIDString]["inactivereported"] = !activeSet;
					counts.totalLongReachTagActivations++;
				}
				reportedTags[tagIDString] = zone[tagIDString];
			}
		}
	}

//	log("getTags. after");
/*	var test = JSON.stringify(reportedTags);
	if(test.indexOf("656B786EC88007E0")!=-1){
		log("getTags. returnTags: " + JSON.stringify(reportedTags));
		log("getTags. zone: " + JSON.stringify(zone));
	}*/
//	log("getTags. after2");
	//writeFile("zone.txt",JSON.stringify(zone));
	return reportedTags;
}

function getDwellTime(tagIDString)
{
	if(zone[tagIDString] == undefined || zone[tagIDString]["lastTime"] == undefined) return -1;
	var startTime = zone[tagIDString]["startTime"].replace("T"," ");
	var lastTime = zone[tagIDString]["lastTime"].replace("T"," ");
	var startTimeDate = new Date(startTime);
	var lastTimeDate = new Date(lastTime);
	var dwellTime = lastTimeDate.getTime() - startTimeDate.getTime();
	return dwellTime;
}

function isTagInactive(tagIDString)
{
	if(zone[tagIDString]["lastTime"] == undefined) return false;
	var lastTime = zone[tagIDString]["lastTime"];
	//if(lastTime.indexOf("T") != -1) lastTime = lastTime.replace("T"," ");
	var lastTimeDate = new Date(lastTime);
	var currentTimeDate = new Date();
	var timeDifference = currentTimeDate.getTime() - lastTimeDate.getTime();
	zone[tagIDString]["timeDifference"] = timeDifference;
	//log(tagIDString + " lastTime: " + lastTimeDate.toString() + " currentTime: " + currentTimeDate.toString() + " timeDifference: " + timeDifference);
	if(timeDifference > zoneConfig["exitTime"]) return true;
	else return false;
}

function startTune()
{
	var waitTime = zoneConfig["exitTime"] * 2;
	lastTunePower = 30;
	if(zoneTuneTags.length > 0)
	{
		isTuning = true;
		zoneTuneAntennas = getActiveAntennasMux();//["1"];
		tuneTagsListHTML();
		tuneSetMuxClear();
		setTuneStatus("Starting tune...");
		setTimeout("tuneAntennas();",waitTime);
	}
	else setTuneStatus("No tags entered.");
}

function addLastShortReach(lastShortReach)
{
	if(lastShortReach == undefined) lastShortReach = $("#lastShortReach").val();
	
	if(lastShortReach != "" && zoneTuneTags.indexOf(lastShortReach) == -1)
	{
		zoneTuneTags.push(lastShortReach);
		$("#lastShortReach").val("");
	}
	tuneTagsListHTML();
}

function clearTuneTags()
{
	zoneTuneTags = [];
	tuneTagsListHTML();
}

function tuneTagsListHTML(retuneTags)
{
	var tuneTagsStr = "";
	for(var i = 0; i < zoneTuneTags.length; i++)
	{
		var color = "white";
		var antennaStr = "";
		
		if(retuneTags != undefined)
		{
			var retuneTagsIndex = indexOfSubStr(retuneTags,zoneTuneTags[i]);
			if(retuneTagsIndex != -1 && retuneTagsIndex != undefined) 
			{
				color = "red";
				var tagArr = retuneTags[retuneTagsIndex].split(";");
				if(tagArr.length > 1) antennaStr = tagArr[1];
			}
			else color = "green";
		}
		tuneTagsStr += "<div style='color:" + color + "'>" + zoneTuneTags[i] + " " + antennaStr + "</div>";
	}
	$("#tuneTagsList").html(tuneTagsStr);
}

function indexOfSubStr(arr,str)
{
	for(var i = 0; i < arr.length; i++)
	{
		var idx = arr[i].indexOf(str);
		if(idx != -1) return idx;
	}
	return -1;
}

function tuneSetMuxClear()
{
	var antennasStr = zoneTuneAntennas.join(" ");
	muxString = "SET MUX " + antennasStr;
	log("tuneSetMuxClear. muxString: " + muxString);
	callC("rfidSocketCommand;"+muxString);
	startRFIDRead(false);
	//callC("rfidSocketCommand;RFID STOP");
	for(var i = 0; i < zoneTuneAntennas.length; i++)
	{
		 setPowerLevel(zoneTuneAntennas[i], lastTunePower,true);
	}
	zone = {};
	startRFIDRead(true);
	//callC("rfidSocketCommand;RFID AUTO");
}

function setTuneStatus(msg)
{
	if(msg != "No tags entered." && zoneTuneAntennas.length > 0) msg += "<br/>Antennas: " + zoneTuneAntennas.join(",") + " Power Level: " + lastTunePower;
	var activeAntennas = getActiveAntennasArr();
	msg += "<br/>Active Antennas: ";
	for(var i = 0;i < activeAntennas.length;i++)
	{
		var powerLevel = activeAntennas[i]["powerLevel"];
		var mux = activeAntennas[i]["muxPosition"];
		msg += mux + ":" + powerLevel + " ";
	}
	$("#tuneStatus").html(msg);
}

function tuneAntennas()
{
	var waitTime = zoneConfig["exitTime"];
	var retuneTags = [];
	zoneTuneAntennas = [];
	
	var activeTags = getActiveTags(true);
	
	var retune = false;
	for(tagIDString in activeTags)
	{
		if(zoneTuneTags.indexOf(tagIDString) != -1)
		{
			var antennas = zone[tagIDString]["antennas"];
			var tagStr = tagIDString + ";";
			for(antennaPos in antennas)
			{
				var lastTime = antennas[antennaPos]["lastTime"];
				if(lastTime == undefined) lastTime = antennas[antennaPos]["startTime"];
				var lastTimeDate = new Date(lastTime);
				var currentTimeDate = new Date();
				var timeDifference = currentTimeDate.getTime() - lastTimeDate.getTime();
				if(timeDifference < zoneConfig["exitTime"])
				{
					var antenna = getAntennaByReadPos(antennaPos);
					var muxPosition = antenna["muxPosition"];
					retune = true;
					
					tagStr += muxPosition + ":" + antenna["powerLevel"] + " ";
					if(zoneTuneAntennas.indexOf(muxPosition) == -1) zoneTuneAntennas.push(muxPosition);
				}
			}
			retuneTags.push(tagStr);
		}
	}
	
	if(retune)
	{
		lastTunePower -= 5;
		
		if(lastTunePower >= 5)
		{
			for(var i = 0; i < zoneTuneAntennas.length; i++)
			{
				 setPowerLevel(zoneTuneAntennas[i], lastTunePower);
			}
			
			tuneTagsListHTML(retuneTags);
			setTuneStatus("Tuning. Power level set to: " + lastTunePower);
			setTimeout("tuneAntennas();",waitTime);
		}
		else
		{
			lastTunePower = 5;
			isTuning = false;
			tuneTagsListHTML(retuneTags);
			setTuneStatus("Tune Error (tags still in zone). Power Level set to: " + lastTunePower);
		}
	}
	else
	{
		isTuning = false;
		tuneTagsListHTML(retuneTags);
		
		for(var i = 0; i < zoneTuneAntennas.length; i++)
		{
			setPowerLevel(zoneTuneAntennas[i], lastTunePower);
		}
		setZoneConfig(zoneConfig);
		
		tagPopulateDiv(activeTags,getInactiveTags(true));
		
		setTuneStatus("Tune Complete.");
	}
}

function deleteInactiveTags()
{
	for(var tagIDString in zone)
	{
		 var inactiveTag = isTagInactive(tagIDString);
		 log("inactivetagcheck. tagIDString: " + tagIDString + " result: " + inactiveTag);
		 if(inactiveTag) delete zone[tagIDString];
	}
	log("deleteInactiveTags. zone: " + JSON.stringify(zone));
}

var lastScanReport = "";
var lastReaderReport = "";
var batRatherThanTemp = true;

function deleteOldInactiveTags()
{
	//moved this to before waitingForLowLevel  getIPAddress
	var ip = "";
  if(!windowsMode) ip = Android.getIPAddress();
  else ip = window.external.getIPAddress();
	//log("got ip address: "+ip);
	if(ip != ""){
		 $('#ipAddress').parent().show();
    	 $('#ipAddress').text(ip);
    } else  $('#ipAddress').parent().hide();
    
	//log("waitingForLowLevel: " + waitingForLowLevel);
	if(waitingForLowLevel) return;
	lastShortUHFTag = "";
	lastShortUHFPower = "";
	lastShortHFTag = "";
	$("#lastShortUHFTag").html(lastShortUHFTag);
	$("#lastShortHFTag").html(lastShortHFTag);
	$("#lastShortReach").val(lastShortUHFTag);
	
//	if(batRatherThanTemp) callC("rfidSocketCommand;GET BAT"); else callC("rfidSocketCommand;RFID TEMP");
//	batRatherThanTemp = !batRatherThanTemp;
	callC("rfidSocketCommand;GET BAT");
	callC("rfidSocketCommand;RFID TEMP");
	
//	log("getting ip address");
	
	
	var count = 0;
	var deleted = 0;
	var inactive = 0;
	var active = 0;
	for(var tagIDString in zone)
	{
		++count;
		 var inactiveTag = isTagInactive(tagIDString);
		 //log("oldInactivetagcheck. tagIDString: " + tagIDString + " result: " + inactiveTag);
		 if(inactiveTag){
		 	inactive++
		 		var timeDifference = zone[tagIDString]["timeDifference"];
			 	if(timeDifference > 3600000){
			 		delete zone[tagIDString];
			 		deleted++;
			 	}
		 } else active++;
	}
	
	counts.currentActiveTags = active;
	counts.currentInactiveTags = inactive;
	counts.totalDeletedInactiveTags += deleted;
	counts.totalLongReachTags = count;
	if(active > counts.maxActiveTags) counts.maxActiveTags = active;
	
	var scanReport = "total tags scanned: " +count +" active: " + active
			 + " inactive: "+ inactive+" deleted: "+deleted+" max active: "+counts.maxActiveTags
			 + " totalLongReach: " + counts.totalLongReachTagActivations
			 + " totalShortReach: " + counts.totalShortReachTagActivations
			 + " totalHfTagActivations: "+ counts.totalHfTagActivations
			 + " hfTagWrites: "+ counts.hfTagWrites
			 + " htTagWriteErrors: "+counts.hfTagWriteErrors
			 + " hfTagReads: "+ counts.hfTagReads
			 + " htTagReadErrors: "+counts.hfTagReadErrors
			 + " shortReachTagWrites: "+counts.shortReachTagWrites
			 + " shortReachTagWriteErrors: "+counts.shortReachTagWriteErrors
			 + " shortReachTagReads: "+counts.shortReachTagReads
			 + " shortReachTagReadErrors: "+counts.shortReachTagReadErrors;
			 
	if(scanReport != lastScanReport){
		log("tag scan report. " +scanReport);
		lastScanReport = scanReport;
		countsPersist();
		countItems();
	}
	
	var readerReport = "batAC: "+counts.batAC
			+ " battery1Charge: "+counts.battery1Charge
			+ " battery2Charge: "+counts.battery2Charge
			+ " readerTemp: "+counts.readerTemp;
	
	if(readerReport != lastReaderReport){
		log("reader report. " +readerReport);
		lastReaderReport = readerReport;
		countItems();
	}
}

function clearZoneFile()
{
	writeFile("zone.txt","");
}

function clearZoneConfigFile()
{
	writeFile("zone.cfg","");
}

function setPowerLevelHTML(id)
{
	var antennaMuxStr = id.replace("pl","");
	var antennaMux = parseInt(antennaMuxStr);
	if(isNaN(antennaMux)) antennaMux = antennaMuxStr;
	
	var newPowerLevelStr = $("#"+id).val();
	var newPowerLevel = parseInt(newPowerLevelStr);
	if(isNaN(newPowerLevel)) newPowerLevel = newPowerLevelStr;
	
	setPowerLevel(antennaMux,newPowerLevel);
}

function setShortReachHTML(id)
{
	var antennaMux = parseInt(id.replace("sr",""));
	var shortReach = ($("#"+id).val() === 'true');
	
	setShortReach(antennaMux,shortReach);
}

function activeTagsHTML(activeTagsArr)
{
	var activeTags = Object.keys(activeTagsArr);
	var activeTagsStr = "";
	
	for(var i = 0; i < activeTags.length; i++)
	{
		var tag = activeTags[i];
		var timeDifferenceT = zone[tag]["timeDifference"];
		var dwellTime = getDwellTime(tag);
		activeTagsStr += tag + " ";
		var currentTimeDate = new Date();
		for(var antenna in zone[tag]["antennas"])
		{
			var lastTime = zone[tag]["antennas"][antenna]["lastTime"];
			if(lastTime == undefined) lastTime = zone[tag]["antennas"][antenna]["startTime"];
			var lastTimeDate = new Date(lastTime);
			var timeDifference = currentTimeDate.getTime() - lastTimeDate.getTime();
			if(timeDifference < zoneConfig["exitTime"]) activeTagsStr += antenna + ":" + zone[tag]["antennas"][antenna]["powerLevel"] + " ";
		}
		activeTagsStr += "<button class='addTagTune' onclick='addLastShortReach(" + '"' + tag + '"' + ");'>Add</button>";
		activeTagsStr += "<ul>";
		if(timeDifferenceT != undefined && dwellTime != -1) activeTagsStr += "<li>Dwell Time: " + dwellTime + " Time Difference: " + timeDifferenceT + "</li>";
		activeTagsStr += "</ul>";
	}
	
	return activeTagsStr;
}

function updateTagsHTMLLoop()
{
	var activeTagsArr = getActiveTags(true);
	var inactiveTagsArr = getInactiveTags(true);
	
	if(/*shouldPopulateTags &&*/ activeTagsArr != null && inactiveTagsArr != null)
	{
		setTimeout(function(){tagPopulateDiv(activeTagsArr,inactiveTagsArr);},100);
		updateLastShortHTML();
	}
	setTimeout("updateTagsHTMLLoop();",1000);
}

var lastActiveTags;
var lastInactiveTags;
var inactiveTagsUnreported = [];
function tagPopulateDiv(activeTagsArr,inactiveTagsArr)
{
	var activeTags = Object.keys(activeTagsArr);
	var activeTagsStr = activeTagsHTML(activeTagsArr);
	
	var inactiveTags = Object.keys(inactiveTagsArr);
	var inactiveTagsStr = "";
	var inactiveTagsUnreportedStr = "";
	
	for(var i = 0; i < inactiveTags.length; i++)
	{
		var tag = inactiveTags[i];
		var timeDifference = zone[tag]["timeDifference"];
		inactiveTagsStr += tag + " ";
		for(var antenna in zone[tag]["antennas"])
		{
			inactiveTagsStr += antenna + ":" + zone[tag]["antennas"][antenna]["powerLevel"] + " ";
		}
		inactiveTagsStr += "<ul>";
		inactiveTagsStr += "<li>Dwell Time: " + getDwellTime(tag) + " Time Difference: " + timeDifference + "</li>";
		inactiveTagsStr += "</ul>";
	}
	
	/*for(var i = 0; i < inactiveTagsUnreported.length; i++)
	{
		var tag = inactiveTagsUnreported[i];
		var timeDifference = 0;
		
		inactiveTagsUnreportedStr += tag + "<ul>";
		if(zone[tag] != undefined) 
		{
			timeDifference = zone[tag]["timeDifference"];
		
			inactiveTagsUnreportedStr += "<li>";
			
			for(var antenna in zone[tag]["antennas"])
			{
				inactiveTagsUnreportedStr += antenna + ":" + zone[tag]["antennas"][antenna]["powerLevel"] + " ";
			}
			
			inactiveTagsUnreportedStr += "</li>";
			inactiveTagsUnreportedStr += "<li>Dwell Time: " + getDwellTime(tag) + " Time Difference: " + timeDifference + "</li>";
		}
		inactiveTagsUnreportedStr += "</ul>";
	}*/
	$(".activeTags").html(activeTagsStr);
	if($("#tags").css('display') == "block") $(".addTagTune").hide();
	$("#inactiveTags").html(inactiveTagsStr);
	$(".activeTagsNum").html(activeTags.length);
	$("#inactiveTagsNum").html(inactiveTags.length);
	//$("#inactiveTagsUnreported").html(inactiveTagsUnreportedStr);
}

function zoneConfigHTML()
{
	var zoneConfigStr = "";
	var antennas = zoneConfig["antennas"];

	for(var i = 0; i < antennas.length; i++)
	{
		var floatVal = "left";
		if(i % 2) floatVal = "right";
		var antennaMux = antennas[i]["muxPosition"];
		var readPosition = antennas[i]["readPosition"];
		var powerLevel = antennas[i]["powerLevel"];
		var shortReach = antennas[i]["shortReach"];
		
		var optionValues = "";
		if(antennaMux == "HF")
		{
			optionValues += "<option value='ON'";
			if(powerLevel == "ON") optionValues += " selected";
			optionValues += ">ON</option>";
			optionValues += "<option value='OFF'";
			if(powerLevel == "OFF") optionValues += " selected";
			optionValues += ">OFF</option>";
		}
		else
		{
			for(var i2 = 0; i2 <= 30; i2 += 5) 
			{
				optionValues += "<option value='"+i2+"'";
				if(i2 == powerLevel) optionValues += " selected";
				optionValues += ">" + i2+"</option>";
			}
		}
		
		var optionValuesShortReach = "<option value='true'";
		if(shortReach) optionValuesShortReach += " selected";
		optionValuesShortReach += ">True</option>";
		optionValuesShortReach += "<option value='false'";
		if(!shortReach) optionValuesShortReach += " selected";
		optionValuesShortReach += ">False</option>";
		
		zoneConfigStr += "<span style='inline-block;float:"+floatVal+";width:300px;'><ul>";
		zoneConfigStr += "<li> Antenna " + antennaMux + " - Read Position: " + readPosition + "</li>";
		
		zoneConfigStr += "<li>Power Level: " + "<select style='width:100px;' onchange='setPowerLevelHTML(" + '"' + "pl" + antennaMux + '")' + "'";
			zoneConfigStr += " style='font-size:22px;' id='pl" + antennaMux + "'>" + optionValues + "</select></li>";
		
		zoneConfigStr += "<li>Short Reach: " + "<select style='width:100px;' onchange='setShortReachHTML(" + '"' + "sr" + antennaMux + '")' + "'";
			zoneConfigStr += " style='font-size:22px;' id='sr" + antennaMux + "'>" + optionValuesShortReach + "</select></li>";
			
		zoneConfigStr += "</ul></span>";
	}
//	console.log("zoneConfigStr: " + zoneConfigStr);
	$("#zoneConfig").html(zoneConfigStr);
}

function updateLastShortHTML()
{
	$("#lastShortUHFTag").html(lastShortUHFTag + " "+lastShortUHFPower);
	$("#lastShortHFTag").html(lastShortHFTag);
	$("#lastShortReach").val(lastShortUHFTag + " "+lastShortUHFPower);
	$(".lastShortTag").show();
}

var shortReachTestState; //'waitRead, waitWrite
var testContext = "";

var contextMap = {
	"android-AUT-T-1":  "RVTT",
	"android-BST-T-1": "PHTT",
	"android-FLD-T-1": "PHTT",
	"android-GMC-T-1": "PHTT",
	"android-GMC-T-2": "PHTT",
	"android-MCY-T-1": "CITT",
	"android-MRS-T-2": "CITT",
	"android-MRS-T2-1": "CITT",
	"android-MSF-T-1": "CITT",
	"android-MSF-T-2": "CITT",
	"android-NCM-T-1": "CITT",
	"android-NFL-T-1": "CITT",
	"android-NFL-T-2": "CITT",
	"android-NNT-T-1": "PHTT",
	"android-NYC-T-1": "PHTT",
	"android-P60-T-1": "MVTT",
	"android-P60-T-1": "MVTT",
	"android-PEP-T-1": "RVTT",
	"android-PPJ-T-1": "RVTT",
	"android-RZN-T-1": "RVTT",
	"android-TBG-T-1": "RVTT",
	"android-VLM-T-1": "RVTT"
	};

function shortReachTestReadSuccess(rfidTransition){
	log("shortReachTestRfidReadSuccess. state: "+shortReachTestState);
	clearTimeout(srTimer);
	if(shortReachTestState == 'waitRead'){
		log("shortReachTestRfidReadSuccess. waitRead with status: "+fs_tag.readStatus.toString());
		if(fs_tag.readStatus){
			clearTimeout(srTimer);
			shortReachTestState = 'waitWrite';
			fs_tag.setField("count",++counts.tagWriteValueCounter);
	    	fs_tag.flushFields("");
	    	srTimer = setTimeout("shortReachTestTimeout();",10000);
	    	sendRecordVisitRfid(testContext);
	    	++shortReachCount;
	    	return;
	    } else{
	    	setTimeout("shortReachTestStart();",1000);
	    	return;
	    }
	 }
	    
	if(shortReachTestState == 'waitWrite'){
		log("tag write status: "+fs_tag.writeStatus.toString());
		clearTimeout(srTimer);
     	if(muxLocked) unlockMux();unlockMux();
     	if(shortReachCount < zoneConfig["shortReachTestCount"]) setTimeout("shortReachTestStart();",1000);
     	return;
	}
}

function shortReachTestTimeout(){
	log("shortReachTestTimeout. ");
	counts.shortReachTagReadErrors++;
	if(shortReachCount < zoneConfig["shortReachTestCount"]) setTimeout("shortReachTestStart();",100);
}

var srTimer = null;

function shortReachTestStart(){
	testIterationCount = 0;
	clearTimeout(srTimer);
	if(!rfidShortReachTestRunning) return;
	$('#short_reach_test_count').html(' '+shortReachCount.toString());
	shortReachTestState = 'waitRead';
	if(muxLocked) unlockMux();
	lockMuxAfterRead();
	fs_tag.readFields('','');
	srTimer = setTimeout("shortReachTestTimeout();",60000);
}


var rfidShortReachTestRunning = false;
var shortReachCount = 0;
function controlRfidShortReachTest(){
	if(rfidShortReachTestRunning){
		log("stop rfid short reach test");
		$('#control_short_reach_test > a').text('Start');
		$('#short_reach_test_count').html(' ');
		clearTimeout(srTimer);
		if(muxLocked) unlockMux();
	} else{
		log("starting rfid short reach test");
		shortReachCount = 0;
		$('#control_short_reach_test > a').text('Stop');
	log("setting test context for: "+eventData["Station_name"]);
	testContext = contextMap[eventData["Station_name"]];
	if(typeof testContext == 'undefined') testContext = eventData["Station_name"];
	log("shortReachTest context: "+testContext);
		
		rfidReadSuccess = shortReachTestReadSuccess;
	tagmapping = {"verification": {
	        "type": "flag",
	        "offset": 0,
	        "bit_number": 1
	    }, "count":{"count":1,"type":"uint8","offset":1}};
    	fs_tag.init(tagmapping);
		setTimeout("shortReachTestStart()",100);
	}
	rfidShortReachTestRunning = ~rfidShortReachTestRunning;
}

var rfidSimulationRunning = false;
function controlRfidSimulation(){
	if(rfidSimulationRunning){
		log("stop rfid simulation");
		$('#control_rfid_simulation > a').text('Start');
		callC("stopZoneSimulation;");
	} else{
		log("starting rfid simulation");
		$('#control_rfid_simulation > a').text('Stop');
				// Enable the following to start simulation	
//************

		args = new Object();
		args.baseLongReach = "0001"; // typically station id
		args.baseShortReach = "1001"; // typically station id + 1000
		args.minTimeLongReach = "1000"; // 1 seconds - arrival
		args.maxTimeLongReach = "60000"; // 60 seconds - arrival
		args.minDwellLongReach = "10000";
		args.maxDwellLongReach = "300000";
		args.minTimeShortReach = "10000"; // 10 seconds
		args.maxTimeShortReach = "60000"; // 60 seconds
		args.duration = "36000000"; // 10 hour
		args = JSON.stringify(args);
		callC("enableZoneSimulation;"+args);
	}
	rfidSimulationRunning = ~rfidSimulationRunning;
}
