log('loaded approver.js..... ');

var aproverScript = loaded;

var getCartsScript;
var getCartsTimer = null;

function getCarts_timer_init(){
    log('init getCarts_timer');
    getCartsTimer = setTimeout(function(){route('error')}, 10000);
}

function getCarts_timmer_clear(){
    log('clear getCarts_timer');
    clearTimeout(getCartsTimer);
}

function getAllCarts(){
    // temp function to switch server
    tempSwitchSever();

    getCarts_timer_init();
    var args = new Object;
    var d = new Date();
    args.ApproverId = loggedInPerson['ParticipantId'];
    args['Password'] = loggedInPerson['Password'];
    setTimeout(function(){ sendCommand('search_get_all_carts', args, getCarts_callback)}, 10);
}

function getCarts_callback(data){
    getCarts_timmer_clear();
    var result = null;

    try{
        result = data;
        log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('getCarts ERROR: '+data);
        route('error');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined ){
        log('network ERROR: bad communitation with server');
        route('error');
        $('.msg').text('network ERROR: bad communitation with server');
        return;
    }
    if (result.length < 1 || result['status'] === false){
        log('user not found');
        route('error');
        $('.msg').text('User not found or User Name and Password are wrong.');
        return;
    }
    if (result['status'] === true){
        log('User Found, setting vars...');
        log(JSON.stringify(result, null, '\t'));
       // writeFile('carts.json', JSON.stringify(result));
        cartsReturned = result['carts'];
        route('cartList');
        tempSwitchBack();
        buildCartList(cartsReturned);
    }
}

var currentCarts = [];
function buildCartList(cartsReturned){
	log('reading');
	log(JSON.stringify(cartsReturned));
	log('read');
	if ($.isEmptyObject(cartsReturned) === true){
		log('no carts');
		$('.carts').text('No Carts To Approve');
		setTimeout(function () {clearFields();loadApp('settings')}, 3000);
		return;
	}
	currentCarts = cartsReturned;
	var items = [];
	$.each(cartsReturned, function (index, data) {
		var sum = 0;

		$.each(data.cart.items, function(index, data){
            sum += Number(data.quantityPrice);
		});

		//data = JSON.parse(data.cart);
		var html = '';
		html += '<div class="cart">';
        html += '<div class="col1" data-index="'+index+'">';
		html += '<h2 class="title">ORDER: '+data.cart["order_id"]+'</h2>';
		html += '<h2 class="title">ORDER TOTAL: $'+sum.toFixed(2)+'</h2>';
		html += '<span class="title">CUSTOMER: '+data.cart["BadgeFirstName"]+' '+data.cart["BadgeLastName"]+'</span>';
		html += '</div>';
        html += '<div class="col2">';
        html += '<a class="approveBtn" data-id="'+data.cart["cart_id"]+'" data-pid="'+data.cart["ParticipantId"]+'">APROVE</a>';
        html += '<a class="rejectBtn" data-id="'+data.cart["cart_id"]+'" data-pid="'+data.cart["ParticipantId"]+'">REJECT</a>';
        html += '</div></div>';
		items.push(html);
	});

	$('.carts').append.apply($('.carts'), items);
	$('.carts .col1').on('click', function(){
        var index = $(this).attr('data-index');
        log('index '+currentCarts[index]);
        var myCart = currentCarts[index];
        approverDetail(myCart);
    });
    $('.approveBtn').on('click', function(){
        var id = $(this).attr('data-id');
        var pid = $(this).attr('data-pid');
        log('id = '+id);
        var state = 'approved';
        fastSubmitUpdate(id, state, pid);
    });
    $('.rejectBtn').on('click', function(){
        var id = $(this).attr('data-id');
        var pid = $(this).attr('data-pid');
        log('id = '+id);
        var state = 'rejected';
        fastSubmitUpdate(id, state, pid);
    });
}

function approverDetail(myCart){
	log('approverDetail');
	log(JSON.stringify(myCart.cart));
	$('.fullname').text('Customer: '+myCart.cart['BadgeFirstName']+' '+myCart.cart['BadgeLastName']);
	$('.cartID').text('Order Id: '+myCart.cart['order_id']);
	$('#cart_id').val(myCart.cart['cart_id']);
	$('#ParticipantId').val(myCart.cart['ParticipantId']);
	var items = [];
	cartItems = [];
	var cartItems = myCart.cart.items
	$.each(cartItems, function (index, data) {
		log(index+' '+data);
		var html = '';
		html += '<div class="detailItem">'
		html += '<h2 class="title">'+data.LongPartDescription+'</h2>';
		html += '<h2 class="itemQuantity">Qty: '+data.quantity+'</h2>';
        var price = data.quantityPrice;
        price = price.toFixed(2); 
		html += '<h2 class="itemTotal">'+price+'</h2>';
		html += '</div>';

		items.push(html);
	});
	$('.cartDetails').append.apply($('.cartDetails'), items);
	var sum = 0;
    $('.itemTotal').each(function() {
        sum += Number($(this).text());
    });
    $('.cartTotal').text('$'+sum.toFixed(2));
	route('cartDetail');
}
function fastSubmitUpdate(id, state, pid){
    pad.ParticipantId = pid;
    pad.cart_id = id;
    pad.cartState = state;
    setTimeout(function(){route('thanks')},10);
}

function submitCartUpdate(){
	tempSwitchSever();

    var d = new Date();
    var args = new Object;
    // args.updateDate = d; // should add date
    args.ParticipantId = pad.ParticipantId;
    args.cartID = pad.cart_id;
    args.cartState = pad.cartState;
    setTimeout(function(){ sendCommand('approver_update',args)}, 100);
}
