var barcodeGuestIDFile = "barcodeGuestID.txt";
var barcodeGuestID = "";
var savedBarcodes = {};

$(document).ready(function() {
	initBarcodeGuestID();
	//setTimeout('sqliteOpenDB();',1000);
});

function sqliteOpenDB()
	{
		var jsonArr = {};
		jsonArr['filename'] = "catalogData.sqlite";
		jsonArr['callback'] = "sqliteOpenDBDone";
		callC("sqliteOpenDB;"+JSON.stringify(jsonArr));
	}

	function sqliteOpenDBDone(result)
	{
	log("sqliteOpenDBDone: " + result);
	runTestQuery();
	}

	function runTestQuery()
	{
		var query = "SELECT * FROM catalog LIMIT 10";
		var jsonArr = {};
		jsonArr['query'] = query;
		jsonArr['callback'] = "runTestQueryDone";
		callC("sqliteRunQuery;"+JSON.stringify(jsonArr));
	}

	function runTestQueryDone(jsonArray)
	{
		var jsonStr = JSON.stringify(jsonArray);
		log("runTestQueryDone: " + jsonStr);
	}

	$('.menuIcon').doubletap(
        function(event){
            // tap twice code here
            log("menuIcon tap 2");
            customRoute("settings");
        },
        600
       );

function initBarcodeGuestID()
{
	readFile(barcodeGuestIDFile,barcodeGuestIDProcess);
}

function barcodeGuestIDProcess(idStr)
{
    log("barcodeGuestIDProcess: " + idStr);
	if(idStr == "") createBarcodeGuestID();
	else barcodeGuestID = idStr;

	writeFile(barcodeGuestIDFile,barcodeGuestID);
	displayBarcodeGuestID();
	sendCommand('search_person',{"guest_id":barcodeGuestID,"id_type":"Guest ID"},getHistoryCallback);
}

function createBarcodeGuestID()
{
	barcodeGuestID = Math.round(Math.random() * (10000 - 1) + 1).toString();
}

function displayBarcodeGuestID()
{
	$("#barcodeGuestID").html("ID: " + barcodeGuestID);
	$("#barcodeCurrentID").html(barcodeGuestID);
}

function changeBarcodeID()
{
	var newBarcodeID = $("#barcodeNewID").val();
	$("#barcodeNewID").val("");
	if(newBarcodeID == "") return;

	barcodeGuestIDProcess(newBarcodeID);
	customRoute("settings");
}


function readBarcode(){
	log("request to read barcode");

	$("#barcodeInfoError").hide();
	$("#barcodeInfoWrapper").hide();
	$("#barcodeSpinner").show();
	$("#productName").html("");
	$("#productImg").attr('src','');

	barcode = true;
	barcoding = true;
	rfidWrite = false;
	rfidReadAfterWrite = false;
	rfidReadSuccess = barcodeFinished;
	callC("readBarcode;");
}

function barcodeFinished(rfidTransition)
{
	log("barcodeFinished: " + lastTagId);
	if(lastTagId == "") {
		//alert("No barcode. Please try again");
		return;
	}

	customRoute("barcodeResult");
	$("#barcodeID").html(lastTagId);
	$("#barcodeDisplay").attr("src","http://searchupc.com/drawupc.aspx?q="+lastTagId);
	callC("getBarcodeInfo;"+lastTagId);
}

function customRoute(routeStr)
{
	currentPage = routeStr;
	nextPage = routeStr;
	route(routeStr);
	$(".next").hide();

	if(routeStr == "settings") $(".barcodeBack").hide();
	else $(".barcodeBack").show();
}

function barcodeInfoProcess(jsonArr)
{
	try {
	jsonArr = jsonArr["0"];
	if(true)
	{
		$("#barcodeInfoError").hide();
		$("#barcodeInfoWrapper").show();
		$("#barcodeSpinner").hide();

		var barcodeData = jsonArr;
		var productName = barcodeData['productname'];
		var productImg = barcodeData['imageurl'];

		var currency = barcodeData['currency'];
		var productPrice = barcodeData['price'];
		if(currency == "USD") productPrice = "$" + productPrice;

		if(productName != " ") {
			$("#productName").html(productName);
			$("#productImg").attr("src",productImg);
			$("#productPrice").html(productPrice);

			savedBarcodes[lastTagId] = barcodeData;
			setPadBarcode();

		}
		else {
			$("#productName").html("Product not found");
			$("#productImg").attr('src','');
			$("#productPrice").html("");
		}

	}
	else {
		$("#barcodeSpinner").hide();
		$("#barcodeInfoError").show();
	}
	}
	catch(err) {
		log("barcodeInfoProcess error: " + err);

		$("#barcodeSpinner").hide();
		$("#barcodeInfoError").show();
	}
}

function setPadBarcode(){
	var tmpPad = {};
    tmpPad["Guest ID"] = barcodeGuestID;
    tmpPad["barcodeData"] = JSON.stringify(savedBarcodes);
    var _pad = {};
    for (var key in tmpPad) {
    	_pad[key] = escape(tmpPad[key]);
    }
    var args = new Object;
    args.id_ = barcodeGuestID;    /// implement as not "combined" for now
    args.id_type = "Guest ID";
    args.pad = JSON.stringify(_pad);
    sendCommand("set_pad",args);
}

function getHistory()
{
    customRoute("barcodeHistory");
    $("#barcodeHistoryWrapper").hide();
    $("#barcodeHistorySpinner").show();

    sendCommand('search_person',{"guest_id":barcodeGuestID,"id_type":"Guest ID"},getHistoryCallback);
}

function getHistoryCallback(data)
{
    try {
    savedBarcodes = {};
    var result = data['result'];
    var htmlStr = "";
    if (result.length <1) {
    	htmlStr = "No records found.";
    }
    else {
    	for(var i = 0; i < result.length; i++)
    	{
    		var timeStamp = result[i]['Pad Updated Timestamp'];

    		var barcodeDataStr = result[i]['barcodeData'];
    		barcodeDataStr = decodeURIComponent(barcodeDataStr);
    		log(barcodeDataStr);
    		var tmpSavedBarcodes = jQuery.parseJSON(barcodeDataStr);

    		$.each(tmpSavedBarcodes, function(key, value)
    		{
    			var barcodeData = value;
    			savedBarcodes[key] = value;
    			var barcode = key;
    			var productName = barcodeData['productname'];
				var productImg = barcodeData['imageurl'];
				var currency = barcodeData['currency'];
				var productPrice = barcodeData['price'];
				if(currency == "USD") productPrice = "$" + productPrice;

				htmlStr += "<div style='border-top:1px solid black; border-bottom:1px solid black;padding-top:2%;padding-bottom:2%;font-size:12px;'>";
					htmlStr += "<span style='display:inline-block;width:40%;vertical-align:top;'><img src='http://searchupc.com/drawupc.aspx?q="+barcode+"' style='vertical-align:top;' /><br/>"+productPrice+"<div style='margin-top:1%;'>"+productName+"</div></span>";
					htmlStr += "<span style='display:inline-block;width:40%;margin-left:3%;'><img src='" + productImg + "' style='width:100%;max-width:200px;'/></span>";
				htmlStr += "</div>";
    		});
    	}
    }

    if(htmlStr == "") htmlStr = "No records found.";
    $("#barcodeHistorySpinner").hide();
    $("#barcodeHistoryWrapper").html(htmlStr);
    $("#barcodeHistoryWrapper").show();
    }
    catch(err) {
    	savedBarcodes = {};
    	setPadBarcode();
    }
}