var canvas;
var myPhoto;
var photoOverlay;
var chosenBackground;
var chromaSettings = {};
// default values
chromaSettings["hue"] = "120";  
chromaSettings["saturation"] = "0.2"; 
chromaSettings["tolerance"] = "30";  
chromaSettings["minValue"] = ".35";
chromaSettings["maxValue"] = ".95";

function displayColor(){
    log('adjusting color for chromaKey');
    var hue,saturation,lightness;
    hue = chromaSettings['hue'];
    saturation = chromaSettings['saturation'];
    lightness = chromaSettings['tolerance']+'%';
    saturation = (saturation*100)+'%';
    log(saturation+' '+lightness);
    log(hue+','+saturation+'%,'+lightness+'%');
    $('.displayColor').css({'background-color': 'hsl('+hue+','+saturation+','+lightness+')'});
}

function setChromaSettings(){
    var chromaSettingsStr = JSON.stringify(chromaSettings);
    callC("setChromaKeySettings;" + chromaSettingsStr);
} 

function backgrondSelection(){
    $('li.backgroundOption').on('click', function(e){
        e = $(e.target);
        //console.log(e);
        $('.backgroundOption img').removeClass('choice');
        $(e).addClass('choice');
        myChoice = $(e).attr('src');
        console.log(myChoice);
        $('#selectedBackground').val(myChoice);

        chosenBackground = myChoice;
        var n = chosenBackground.lastIndexOf("/")+1;
        chosenBackground = chosenBackground.substr(n)
        var m = chosenBackground.lastIndexOf(".");
        chosenBackground = chosenBackground.substr(0,m);
        console.log(chosenBackground);
        photoOverlay = chosenBackground+'.png';
        console.log(photoOverlay);
    });
    $('.backgroundOption img').removeClass('choice');
}

function sendPhotoMultiRfid(msg){
    var d = new Date();
    var args = new Object;

    var i = lastTagId;
    var I = photoTags.indexOf(i);
    photoTags.splice(I,1);
    args.forced_type = 'email';
    args.guest_id = lastTagId;
    args.id_type = "RFID Tag ID";
    args.photo_name = "photos/"+lastTagId+"_"+d.getTime()+".jpg";
    args.time_stamp = d.getTime();
    args.buddies = photoTags;

    args.photo = myPhoto;
    args.message_name = msg;
    //log("args = "+JSON.stringify(args));
    sendCommand("upload_photo",args);
}

function reloadPhoto(){
    canvas.remove(canvas.item(0));
    callC("chromaKeyRecall;");
   // setTimeout(loadpicture, 500);
}

function loadpicture(){
    log('loadpicture');
    fabric.Image.fromURL(currentPicture, function(img) {
        var oImg = img.set({ left: 300, top: 400, angle: 90});
        oImg.hasControls = oImg.hasBorders = false;
        oImg.applyFilters(canvas.renderAll.bind(canvas));
        canvas.add(oImg);
    });
}

function greenScreenElementsLoad(){
    var backgroundImageChoice = $('#selectedBackground').val();
    var overlay = 'img/backgrounds/'+photoOverlay;
    console.log('backgroundImageChoice = '+backgroundImageChoice+' overlay = '+overlay);
    
    // init the canvas
    canvas = new fabric.Canvas('c', {backgroundImage: backgroundImageChoice });
    canvas.setOverlayImage(overlay, canvas.renderAll.bind(canvas),{overlayImageLeft: 0, overlayImageTop:660});
    fabric.Image.fromURL(currentPicture, function(img) {
        var oImg = img.set({ left: 300, top: 400, angle: 90});
        oImg.hasControls = oImg.hasBorders = false;
        oImg.applyFilters(canvas.renderAll.bind(canvas));
        canvas.add(oImg);
    });
}

function applyFilterValue(prop, value) {
    var obj = canvas.item(0);
    //console.log(obj);
    if (obj.filters[0]) {
      console.log('obj has filters :'+ value); 
      value = value*1;
      obj.filters[0][prop] = value;
      obj.applyFilters(canvas.renderAll.bind(canvas));
    }
}