/*!
 * jQuery Double Tap Plugin.
 * 
 * Copyright (c) 2010 Raul Sanchez (http://www.sanraul.com)
 * 
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 */

/*
 * Changed the isTouch detection form isIOS
 * http://alastairc.ac/2010/03/detecting-touch-based-browsing/
 */

(function($){
	// Determine if we on iPhone or iPad
	var isTouch = false;

	// set touch or click
	function isTouchDevice() {
	   var el = document.createElement('div');
	   el.setAttribute('ontouchmove', 'return;');
	   if(typeof el.ontouchmove == "function"){
	      	isTouch = true;
	      	return true;
	   }else {
       		isTouch = false;
       		return false;
	   }
	}
	isTouchDevice();

	$.fn.doubletap = function(onDoubleTapCallback, onTapCallback, delay){
		var eventName, action;
		delay = delay == null? 500 : delay;
		eventName = isTouch == true? 'touchend' : 'click';
		
		$(this).bind(eventName, function(event){
			var now = new Date().getTime();
			var lastTouch = $(this).data('lastTouch') || now + 1 /** the first time this will make delta a negative number */;
			var delta = now - lastTouch;
			clearTimeout(action);
			if(delta<delay && delta>0){
				//$(this).trigger('doubletap', [event]);
				if(onDoubleTapCallback != null && typeof onDoubleTapCallback == 'function'){
					onDoubleTapCallback(event);
				}
			}else{
				$(this).data('lastTouch', now);
				action = setTimeout(function(evt){
					if(onTapCallback != null && typeof onTapCallback == 'function'){
						onTapCallback(evt);
					}
					clearTimeout(action);   // clear the timeout
				}, delay, [event]);
			}
			$(this).data('lastTouch', now);
		});
	};
})(jQuery);