log('loading panel.js');

 var panelTapTimer = null;
 
 function fixIcons(){
	$('.panelIcon').doubletap(
	    function(event){
	        // tap twice code here
	        log("panelIcon double tap");
	        if(panelTapTimer != null){
	        	clearTimeout(panelTapTimer);
	        	panelTapTimer = null;
				launchControl(eventData,eventStatus);
				} else{
					log("starting panel timer -- must double tap again in 10 seconds");
					panelTapTimer = setTimeout("killPanelTimer();",10000);
				}
	    },
	    function(event){
	    },
	    600
	);
}

function killPanelTimer(){
	log("panel timer killed");
	panelTapTimer = null;
}
    
var pendding = 0; // If bigger than 0 will show count by gear
function penddingRecords() {
    if (pendding > 0) {
        // if pendding is greater than 0 show div with pendding value
        $('.pendding').remove();
        $('.header').append('<div class="pendding">'+pendding+'</div>');
    }else{
        // if pendding is 0 then remove the div
        if ($('.pendding').length !=0) {
            $('.pendding').remove();
        }
    }
}

function readCounts(){
    try{
        $.getJSON('counts.json', function(data) {
            for (var key in data) {
                counts[key] = data[key];
            }
            //alert(JSON.stringify(counts));
        });
    } catch(err){
      log("no initial counts.json file");
    }
}

var lastPersistedCounts = '';

function countsPersist(){
    currentCounts = JSON.stringify(counts);
    if(currentCounts == lastPersistedCounts) return;
    lastPersistedCounts = currentCounts;
    writeFile('counts.json', currentCounts);
}

function eventRead(){
    loadEventList();
    if (eventData.eventUID === ''){
        eventReadError(); 
        return;
    }
    $.getJSON('Event.cfg', function(data){
        eventData = data;

        if (eventData.eventUID === undefined || eventData.eventUID === ''){
            eventReadError();
            return;
        }
        currentEvent = eventData.eventUID;

        myEvent = eventList[currentEvent];
        jConfirm('Current event is:<br/><strong style="font-size: 2em">'+myEvent+'</strong style="font-size: 2em"><br/>Is this correct?', 'CONFIRM EVENT', function(r) {
            if (r === false){
                jAlert('Use the select list to select your event.', 'SELECT EVENT', panelOpen('.actions'));
            }
        });
        $('#popup_ok').attr('value', 'YES');
        $('#popup_cancel').attr('value', 'NO');
    });
}

function panelOpen(panelSection){
	log("panelOpen called");
    launchControl(window.eventData, window.eventStatus);
    $(panelSection).addClass('active');
    $('.active').parent().next().slideDown();
}

function countItems(){
    var data = counts;
    for ( var key in data){
        var obj = data[key];
        //alert( key+' = '+ obj);
        if (obj === 0 || obj === ''){
            $('#'+key).parent().hide();
        }
        if (obj) {
            if (key === 'barcode'){
                // do nothing
            }else{
                $('#'+key).parent().show();
                $('#'+key).text(obj);
            }
        }
    }
}

function eventItems(){
    var data = eventData;
    for ( var key in data){
        var obj = data[key];
        //alert( key+' = '+ obj);
        if (obj === '' || obj === 0){
            $('#'+key).parent().hide();
        }
        if (obj) {
            if (key === 'barcode'){
                // do nothing
            }else{
                $('#'+key).parent().show();
                $('#'+key).text(obj);
            }
        }
    }
}

function statusItems(){
    var data = eventStatus;
    for ( var key in data){
        var obj = data[key];
        //alert( key+' = '+ obj);
        if (obj === '' || obj === 0){
            $('#'+key).parent().hide();
        }
        if (obj) {
            $('#'+key).parent().show();
            $('#'+key).text(obj);
        }
    }
}

$('#barcode').on('click', function(){
    if (barcoding === true){
        barcoding = false;
        barcodeDisabled();
        eventData.barcode = "disabled";
    }else{
        barcoding = true;
        eventData.barcode = "enabled";
        barcodeEnabled();
    }
});

var rfidReadSuccessSave = null;

function panelReadTag(){
	rfidReadSuccessSave = rfidReadSuccess;
	rfidReadSuccess = panelGotTag;
	fs_tag.readFields("","");
}

function panelGotTag(){
	readTagHTML();
    rfidReadSuccess = rfidReadSuccessSave;
}

function writeTag(){

}

function readTagHTML()
{
	var tagConfigStr = "";
	var i=0
	for (var field in fs_tag.map)
	{
     if (fs_tag.map.hasOwnProperty(field)) {
		var floatVal = "left";
		if(i % 2) floatVal = "right";
		i++;
		var val = fs_tag.getField(field);
		
		var optionValues = "";
		switch(field.type){
			case "unit8":
			case "unit32":
				for(var i2 = 0; i2 <= 30; i2 += 5) 
				{
					optionValues += "<option value='"+i2+"'";
					if(i2 == val) optionValues += " selected";
					optionValues += ">" + i2+"</option>";
				}
			  break;
			case "flag":
			    optionValues += "<option value='1'";
				if(fs_tag.getField(field) == 1) optionValues += " selected";
				optionValues += ">1</option>";
				optionValues += "<option value='0'";
				if(fs_tag.getField(field) == 0) optionValues += " selected";
				optionValues += ">0</option>";
				  break;
			case "string":
			
			  break;
		}

		log("readTagHTML. options: "+optionValues);
		
		tagConfigStr += "<span style='inline-block;float:"+floatVal+";width:300px;'><ul>";
		tagConfigStr += "<li> " + field + "</li>";
		
		tagConfigStr += "<li>Value: " + "<select style='width:100px;' onchange='setTagHTML(" + '"' + field + '")' + "'";
			tagConfigStr += " style='font-size:22px;' id='tv" + field + "'>" + optionValues + "</select></li>";
			
		tagConfigStr += "</ul></span>";
	}
	}
//	console.log("zoneConfigStr: " + zoneConfigStr);
	$("#tagConfig").html(tagConfigStr);
}

function setTagHTML(field)
{
	log("request to change tag field: "+field);
	var tagStr = id.replace("pl","");
	var tag = parseInt(antennaMuxStr);
	
	var newTagStr = $("#tv"+field).val();
	var newTagVal = parseInt(newTagStr);
	if(isNaN(newTagVal)) newTagVal = 0;
	
	fs_tag.setField(field,newTagVal);
	
	fs_tag.flushFields("");
}

var clickHandler = ('ontouchstart' in document.documentElement ? "touchstart" : "click");

//Attaching function to panel actions
$('#update_zip').on(clickHandler, function(){autoRecon = false;andy.updateZip.go()}); /* surface- change to "click" */
$('#back_bootstrap').on(clickHandler,function(){andy.returnToBootstrap.go()});
$('#upload_log').on(clickHandler,function(){callC("uploadLog;{}")});
//$('#purge_top').on('touchstart',function(){callC("purgeQueueTop;{}")});
$('#purge_top').on(clickHandler,function(){callC("uploadStats;{}")});
$('#clear_tag').on('click',function(){fs_tag.clearTag()});
$('#read_tag').on('click',function(){panelReadTag()});
$('#read_tag').on('click',function(){panelReadTag()});
$('#enable_minime').on('click',function(){minimeEnabled()});

(function($) {
    var allPanels = $('.accordion > dd').hide();
    $('.accordion > dt > a').click(function() {
        $this = $(this);
        $target =  $this.parent().next();
        if(!$target.hasClass('active')){
            $('.accordion > dt > a').removeClass('active');
            $this.addClass('active');
            allPanels.removeClass('active').slideUp();
            $target.addClass('active').slideDown();
            $('body').scrollTop(1);
        }else{
            $('.accordion > dt > a').removeClass('active');
            $target.removeClass('active').slideUp();
        }
        return false;
    });
})(jQuery);
