//
// log in functions
//
log('loading... reports.js');

var reportsScript;
var reportsTimer = null;
var ApprovedData, ApprovedDataFormat=[], PendingData, PendingDataFormat=[];
var Pending = false;

function reports_timer_init(){
    log('init reports_timer');
    reportsTimer = setTimeout(function(){route('error-page')}, 10000);
}

function reports_timmer_clear(){
    log('clear reports_timer');
    clearTimeout(reportsTimer);
}

function my_reports(){
    

    // temp function to switch server
    tempSwitchSever();
    reports_timer_init();
    var d = new Date();
    var args = new Object;
    var pid = loggedInPerson['ParticipantId'];
    args.ParticipantId = pid;
    args.reportDate = d;
    setTimeout(function(){ sendCommand('search_reports',args,reports_callback)}, 100);
}

function reports_callback(data){
    reports_timmer_clear();
    var result = null;

    try{
        result = data;
        log(JSON.stringify(result, null, '\t'));
    }catch(e){
        log('reports ERROR: '+data);
        route('error-page');
        $('.msg').text(data);
        return;
    }
    if (result == null || typeof result == undefined ){
        log('network ERRROR: bad communitation with server');
        route('error-page');
        $('.msg').text('network ERRROR: bad communitation with server');
        return;
    }
    if (result.length < 1 || result['status'] === false){
        log('user not found');
        route('error-page');
        return;
    }
    if (result['status'] === true){
        log('User Found, setting reports...');
        log(JSON.stringify(result, null, '\t'));
        ApprovedData = result['data']['Order Status']['Approved'];
        PendingData = result['data']['Order Status']['Pending'];
        parseReportData();
    }
}
// charts global options
//Chart.defaults.global.responsive = true;

var chartApprovedOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%> $<span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>"};
var chartPendingOptions = {legendTemplate : "<ul class=\"legend center\"><% for (var i=0; i<segments.length; i++){%><li><span style=\"background-color:<%=segments[i].fillColor%>\"></span><%if(segments[i].label){%><%=segments[i].label%><%}%> $<span class=\"money\"><%if(segments[i].value){%><%=segments[i].value%><%}%></span></li><%}%></ul>"};

function parseReportData(){
    log('parseReportData');
    ApprovedDataFormat = [];
    PendingDataFormat = [];
    var sum1 = 0; 
    $.each(ApprovedData, function (index, data) {
        log(index+' '+JSON.stringify(data));
        var myColor = colorGen();
        sum1 += Number(data['amount']);
        if (data['numcarts'] > 0){
            myLabel = data['name']+'  '+data['numcarts']; 
        }else{
            myLabel = data['name'];
        }
        ApprovedDataFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
    });
    $('#Approved-report .revenue').text('Total: $'+sum1.toFixed(2));
    var sum2 = 0;
    $.each(PendingData, function (index, data) {
        log(index+' '+JSON.stringify(data));
        var myColor = colorGen();
        sum2 += Number(data['amount']);
        var myLabel;
        if (data['numcarts'] > 0){
            myLabel = data['name']+'  '+data['numcarts']; 
        }else{
            myLabel = data['name'];
        }
        PendingDataFormat.push({'value': Number(data['amount']),'color': myColor,'highlight': myColor,'label': myLabel });
    });
    $('#Pending-report .revenue').text('Total: $'+sum2.toFixed(2));
    log(JSON.stringify(ApprovedDataFormat, null,'\t'));
    log(JSON.stringify(PendingDataFormat, null,'\t'));
    if (Pending != true){
        route('Approved-report');
    }else{
        route('Pending-report');
    }
}

function colorGen(){
    return "#000000".replace(/0/g,function(){return (~~(Math.random()*16)).toString(16);});
}
var myApprovedChart = '';
function createApprovedReports(){
    log('myApprovedChart = '+myApprovedChart);
    if (myApprovedChart){
        log('myApprovedChart inside');
        myApprovedChart.clear();
        myApprovedChart.destroy();
    }
    log('------ creatingApprovedReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myApprovedChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(ApprovedDataFormat));
    myApprovedChart = new Chart(ctx).Pie(ApprovedDataFormat,chartApprovedOptions); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myApprovedChart.generateLegend();
    $('#Approved-report .legend').remove();
    $('#Approved-report .chartHolder').append(legendHolder);

    $("#myApprovedChart").on('click',function(evt){
            log('touch');
            var activePoints = myApprovedChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(ApprovedDataFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(ApprovedData[ind]['detail']);
                if (moreDetails != true){
                    log(JSON.stringify(ApprovedData[ind]['detail'], null, '\t'));
                    ApprovedData = ApprovedData[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}
var myPendingChart = '';
function createPendingReports(){
    log('myPendingChart = '+myPendingChart);
    if (myPendingChart){
        log('myPendingChart inside');
        myPendingChart.clear();
        myPendingChart.destroy();
    }
    log('------ creatingPendingReports');
    // Get context with jQuery - using jQuery's .get() method.
    var ctx = $('#myPendingChart').get(0).getContext("2d");
    // This will get the first returned node in the jQuery collection.
    log('chart Data = '+JSON.stringify(PendingDataFormat));
    myPendingChart = new Chart(ctx).Pie(PendingDataFormat,chartPendingOptions); 

    // generate legend
    var legendHolder = document.createElement('div');
    legendHolder.innerHTML = myPendingChart.generateLegend();
    $('#Pending-report .legend').remove();
    $('#Pending-report .chartHolder').append(legendHolder);

    $("#myPendingChart").on('click',function(evt){
            var activePoints = myPendingChart.getSegmentsAtEvent(evt);
            var segment = activePoints[0].label;
            var ind = '';
            $.each(PendingDataFormat, function(index, data){
                if (data.label === segment){
                    ind = index;
                }
            });
            log('index = '+ind);
            if (ind !== ''){
                var moreDetails = $.isEmptyObject(PendingData[ind]['detail']);

                if (moreDetails != true){
                    log(JSON.stringify(PendingData[ind]['detail'], null, '\t'));
                    PendingData = PendingData[ind]['detail'];
                    parseReportData();
                }
            }
        }
    );

}

function moneyFixed(){
    $( '.money' ).each(function( index ) {
      var money  = Number($( this ).text());
      money = money.toFixed(2);
      $(this).text(money);
    });
}
